/*     */ package org.apache.batik.swing;
/*     */ 
/*     */ import java.awt.BorderLayout;
/*     */ import java.awt.Component;
/*     */ import java.awt.Dimension;
/*     */ import java.awt.Rectangle;
/*     */ import java.awt.event.ComponentAdapter;
/*     */ import java.awt.event.ComponentEvent;
/*     */ import java.awt.geom.AffineTransform;
/*     */ import java.awt.geom.Rectangle2D;
/*     */ import javax.swing.BoundedRangeModel;
/*     */ import javax.swing.Box;
/*     */ import javax.swing.JPanel;
/*     */ import javax.swing.JScrollBar;
/*     */ import javax.swing.event.ChangeEvent;
/*     */ import javax.swing.event.ChangeListener;
/*     */ import org.apache.batik.bridge.UpdateManagerEvent;
/*     */ import org.apache.batik.bridge.UpdateManagerListener;
/*     */ import org.apache.batik.bridge.ViewBox;
/*     */ import org.apache.batik.dom.events.NodeEventTarget;
/*     */ import org.apache.batik.gvt.GraphicsNode;
/*     */ import org.apache.batik.swing.gvt.GVTTreeRendererEvent;
/*     */ import org.apache.batik.swing.gvt.GVTTreeRendererListener;
/*     */ import org.apache.batik.swing.gvt.JGVTComponentListener;
/*     */ import org.apache.batik.swing.svg.GVTTreeBuilderEvent;
/*     */ import org.apache.batik.swing.svg.GVTTreeBuilderListener;
/*     */ import org.apache.batik.swing.svg.SVGDocumentLoaderAdapter;
/*     */ import org.apache.batik.swing.svg.SVGDocumentLoaderEvent;
/*     */ import org.apache.batik.swing.svg.SVGDocumentLoaderListener;
/*     */ import org.w3c.dom.svg.SVGDocument;
/*     */ import org.w3c.dom.svg.SVGSVGElement;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class JSVGScrollPane
/*     */   extends JPanel
/*     */ {
/*     */   protected JSVGCanvas canvas;
/*     */   protected JPanel horizontalPanel;
/*     */   protected JScrollBar vertical;
/*     */   protected JScrollBar horizontal;
/*     */   protected Component cornerBox;
/*     */   protected boolean scrollbarsAlwaysVisible;
/*     */   protected SBListener hsbListener;
/*     */   protected SBListener vsbListener;
/*     */   protected Rectangle2D viewBox;
/*     */   protected boolean ignoreScrollChange;
/*     */   
/*     */   public JSVGScrollPane(JSVGCanvas canvas) {
/*  93 */     this.scrollbarsAlwaysVisible = false;
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*  98 */     this.viewBox = null;
/*  99 */     this.ignoreScrollChange = false;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 107 */     this.canvas = canvas;
/* 108 */     canvas.setRecenterOnResize(false);
/*     */ 
/*     */     
/* 111 */     this.vertical = new JScrollBar(1, 0, 0, 0, 0);
/* 112 */     this.horizontal = new JScrollBar(0, 0, 0, 0, 0);
/*     */ 
/*     */     
/* 115 */     this.horizontalPanel = new JPanel(new BorderLayout());
/* 116 */     this.horizontalPanel.add(this.horizontal, "Center");
/* 117 */     this.cornerBox = Box.createRigidArea(new Dimension((this.vertical.getPreferredSize()).width, (this.horizontal.getPreferredSize()).height));
/*     */ 
/*     */     
/* 120 */     this.horizontalPanel.add(this.cornerBox, "East");
/*     */ 
/*     */     
/* 123 */     this.hsbListener = createScrollBarListener(false);
/* 124 */     this.horizontal.getModel().addChangeListener(this.hsbListener);
/*     */     
/* 126 */     this.vsbListener = createScrollBarListener(true);
/* 127 */     this.vertical.getModel().addChangeListener(this.vsbListener);
/*     */ 
/*     */     
/* 130 */     updateScrollbarState(false, false);
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 135 */     setLayout(new BorderLayout());
/* 136 */     add(canvas, "Center");
/* 137 */     add(this.vertical, "East");
/* 138 */     add(this.horizontalPanel, "South");
/*     */ 
/*     */     
/* 141 */     canvas.addSVGDocumentLoaderListener(createLoadListener());
/*     */ 
/*     */     
/* 144 */     ScrollListener xlistener = createScrollListener();
/* 145 */     addComponentListener(xlistener);
/* 146 */     canvas.addGVTTreeRendererListener(xlistener);
/* 147 */     canvas.addJGVTComponentListener(xlistener);
/* 148 */     canvas.addGVTTreeBuilderListener(xlistener);
/* 149 */     canvas.addUpdateManagerListener(xlistener);
/*     */   }
/*     */ 
/*     */   
/* 153 */   public boolean getScrollbarsAlwaysVisible() { return this.scrollbarsAlwaysVisible; }
/*     */ 
/*     */   
/*     */   public void setScrollbarsAlwaysVisible(boolean vis) {
/* 157 */     this.scrollbarsAlwaysVisible = vis;
/* 158 */     resizeScrollBars();
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 166 */   protected SBListener createScrollBarListener(boolean isVertical) { return new SBListener(this, isVertical); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 173 */   protected ScrollListener createScrollListener() { return new ScrollListener(this); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 181 */   protected SVGDocumentLoaderListener createLoadListener() { return new SVGScrollDocumentLoaderListener(this); }
/*     */ 
/*     */ 
/*     */   
/* 185 */   public JSVGCanvas getCanvas() { return this.canvas; }
/*     */   
/*     */   class SVGScrollDocumentLoaderListener extends SVGDocumentLoaderAdapter { private final JSVGScrollPane this$0;
/*     */     
/* 189 */     SVGScrollDocumentLoaderListener(JSVGScrollPane this$0) { this.this$0 = this$0; }
/*     */     public void documentLoadingCompleted(SVGDocumentLoaderEvent e) {
/* 191 */       NodeEventTarget root = (NodeEventTarget)e.getSVGDocument().getRootElement();
/*     */       
/* 193 */       root.addEventListenerNS("http://www.w3.org/2001/xml-events", "SVGZoom", new JSVGScrollPane$1(this), false, null);
/*     */     } }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void reset() {
/* 216 */     this.viewBox = null;
/* 217 */     updateScrollbarState(false, false);
/* 218 */     revalidate();
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected void setScrollPosition() {
/* 227 */     checkAndSetViewBoxRect();
/* 228 */     if (this.viewBox == null)
/*     */       return; 
/* 230 */     AffineTransform crt = this.canvas.getRenderingTransform();
/* 231 */     AffineTransform vbt = this.canvas.getViewBoxTransform();
/* 232 */     if (crt == null) crt = new AffineTransform(); 
/* 233 */     if (vbt == null) vbt = new AffineTransform();
/*     */     
/* 235 */     Rectangle r2d = vbt.createTransformedShape(this.viewBox).getBounds();
/*     */     
/* 237 */     int tx = 0, ty = 0;
/* 238 */     if (r2d.x < 0) tx -= r2d.x; 
/* 239 */     if (r2d.y < 0) ty -= r2d.y;
/*     */     
/* 241 */     int deltaX = this.horizontal.getValue() - tx;
/* 242 */     int deltaY = this.vertical.getValue() - ty;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 248 */     crt.preConcatenate(AffineTransform.getTranslateInstance(-deltaX, -deltaY));
/*     */     
/* 250 */     this.canvas.setRenderingTransform(crt);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected class SBListener
/*     */     implements ChangeListener
/*     */   {
/*     */     protected boolean inDrag;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*     */     protected int startValue;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*     */     protected boolean isVertical;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*     */     private final JSVGScrollPane this$0;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*     */     public SBListener(JSVGScrollPane this$0, boolean vertical) {
/* 310 */       this.this$0 = this$0; this.inDrag = false;
/* 311 */       this.isVertical = vertical;
/*     */     }
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*     */     public void stateChanged(ChangeEvent e) {
/* 318 */       if (this.this$0.ignoreScrollChange)
/*     */         return; 
/* 320 */       Object src = e.getSource();
/* 321 */       if (!(src instanceof BoundedRangeModel)) {
/*     */         return;
/*     */       }
/* 324 */       int val = this.isVertical ? this.this$0.vertical.getValue() : this.this$0.horizontal.getValue();
/*     */ 
/*     */       
/* 327 */       BoundedRangeModel brm = (BoundedRangeModel)src;
/* 328 */       if (brm.getValueIsAdjusting()) {
/* 329 */         if (!this.inDrag) {
/* 330 */           this.inDrag = true;
/* 331 */           this.startValue = val;
/*     */         } else {
/*     */           AffineTransform affineTransform;
/* 334 */           if (this.isVertical) {
/* 335 */             affineTransform = AffineTransform.getTranslateInstance(0.0D, (this.startValue - val));
/*     */           } else {
/*     */             
/* 338 */             affineTransform = AffineTransform.getTranslateInstance((this.startValue - val), 0.0D);
/*     */           } 
/*     */           
/* 341 */           this.this$0.canvas.setPaintingTransform(affineTransform);
/*     */         } 
/*     */       } else {
/* 344 */         if (this.inDrag) {
/* 345 */           this.inDrag = false;
/* 346 */           if (val == this.startValue) {
/* 347 */             this.this$0.canvas.setPaintingTransform(new AffineTransform());
/*     */             return;
/*     */           } 
/*     */         } 
/* 351 */         this.this$0.setScrollPosition();
/*     */       } 
/*     */     } }
/*     */   
/*     */   protected class ScrollListener extends ComponentAdapter implements JGVTComponentListener, GVTTreeBuilderListener, GVTTreeRendererListener, UpdateManagerListener { protected boolean isReady;
/*     */     
/*     */     protected ScrollListener(JSVGScrollPane this$0) {
/* 358 */       this.this$0 = this$0;
/*     */ 
/*     */ 
/*     */       
/* 362 */       this.isReady = false;
/*     */     }
/*     */     private final JSVGScrollPane this$0;
/*     */     public void componentTransformChanged(ComponentEvent evt) {
/* 366 */       if (this.isReady) {
/* 367 */         this.this$0.resizeScrollBars();
/*     */       }
/*     */     }
/*     */ 
/*     */     
/*     */     public void componentResized(ComponentEvent evt) {
/* 373 */       if (this.isReady) {
/* 374 */         this.this$0.resizeScrollBars();
/*     */       }
/*     */     }
/*     */     
/*     */     public void gvtBuildStarted(GVTTreeBuilderEvent e) {
/* 379 */       this.isReady = false;
/*     */       
/* 381 */       this.this$0.updateScrollbarState(false, false);
/*     */     }
/*     */     
/*     */     public void gvtBuildCompleted(GVTTreeBuilderEvent e) {
/* 385 */       this.isReady = true;
/* 386 */       this.this$0.viewBox = null;
/*     */     }
/*     */     
/*     */     public void gvtRenderingCompleted(GVTTreeRendererEvent e) {
/* 390 */       if (this.this$0.viewBox == null) {
/* 391 */         this.this$0.resizeScrollBars();
/*     */         
/*     */         return;
/*     */       } 
/* 395 */       Rectangle2D newview = this.this$0.getViewBoxRect();
/* 396 */       if (newview.getX() != this.this$0.viewBox.getX() || newview.getY() != this.this$0.viewBox.getY() || newview.getWidth() != this.this$0.viewBox.getWidth() || newview.getHeight() != this.this$0.viewBox.getHeight()) {
/*     */ 
/*     */ 
/*     */         
/* 400 */         this.this$0.viewBox = newview;
/* 401 */         this.this$0.resizeScrollBars();
/*     */       } 
/*     */     }
/*     */     
/*     */     public void updateCompleted(UpdateManagerEvent e) {
/* 406 */       if (this.this$0.viewBox == null) {
/* 407 */         this.this$0.resizeScrollBars();
/*     */         
/*     */         return;
/*     */       } 
/* 411 */       Rectangle2D newview = this.this$0.getViewBoxRect();
/* 412 */       if (newview.getX() != this.this$0.viewBox.getX() || newview.getY() != this.this$0.viewBox.getY() || newview.getWidth() != this.this$0.viewBox.getWidth() || newview.getHeight() != this.this$0.viewBox.getHeight()) {
/*     */ 
/*     */ 
/*     */         
/* 416 */         this.this$0.viewBox = newview;
/* 417 */         this.this$0.resizeScrollBars();
/*     */       } 
/*     */     }
/*     */ 
/*     */     
/*     */     public void gvtBuildCancelled(GVTTreeBuilderEvent e) {}
/*     */ 
/*     */     
/*     */     public void gvtBuildFailed(GVTTreeBuilderEvent e) {}
/*     */     
/*     */     public void gvtRenderingPrepare(GVTTreeRendererEvent e) {}
/*     */     
/*     */     public void gvtRenderingStarted(GVTTreeRendererEvent e) {}
/*     */     
/*     */     public void gvtRenderingCancelled(GVTTreeRendererEvent e) {}
/*     */     
/*     */     public void gvtRenderingFailed(GVTTreeRendererEvent e) {}
/*     */     
/*     */     public void managerStarted(UpdateManagerEvent e) {}
/*     */     
/*     */     public void managerSuspended(UpdateManagerEvent e) {}
/*     */     
/*     */     public void managerResumed(UpdateManagerEvent e) {}
/*     */     
/*     */     public void managerStopped(UpdateManagerEvent e) {}
/*     */     
/*     */     public void updateStarted(UpdateManagerEvent e) {}
/*     */     
/*     */     public void updateFailed(UpdateManagerEvent e) {} }
/*     */ 
/*     */   
/*     */   protected void resizeScrollBars() {
/* 449 */     this.ignoreScrollChange = true;
/*     */     
/* 451 */     checkAndSetViewBoxRect();
/* 452 */     if (this.viewBox == null)
/*     */       return; 
/* 454 */     AffineTransform vbt = this.canvas.getViewBoxTransform();
/* 455 */     if (vbt == null) vbt = new AffineTransform();
/*     */     
/* 457 */     Rectangle r2d = vbt.createTransformedShape(this.viewBox).getBounds();
/*     */ 
/*     */ 
/*     */     
/* 461 */     int maxW = r2d.width;
/* 462 */     int maxH = r2d.height;
/* 463 */     int tx = 0, ty = 0;
/* 464 */     if (r2d.x > 0) { maxW += r2d.x; }
/* 465 */     else { tx -= r2d.x; }
/* 466 */      if (r2d.y > 0) { maxH += r2d.y; }
/* 467 */     else { ty -= r2d.y; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 474 */     Dimension vpSize = updateScrollbarVisibility(tx, ty, maxW, maxH);
/*     */ 
/*     */     
/* 477 */     this.vertical.setValues(ty, vpSize.height, 0, maxH);
/* 478 */     this.horizontal.setValues(tx, vpSize.width, 0, maxW);
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 483 */     this.vertical.setBlockIncrement((int)(0.9F * vpSize.height));
/* 484 */     this.horizontal.setBlockIncrement((int)(0.9F * vpSize.width));
/*     */ 
/*     */ 
/*     */     
/* 488 */     this.vertical.setUnitIncrement((int)(0.2F * vpSize.height));
/* 489 */     this.horizontal.setUnitIncrement((int)(0.2F * vpSize.width));
/*     */     
/* 491 */     doLayout();
/* 492 */     this.horizontalPanel.doLayout();
/* 493 */     this.horizontal.doLayout();
/* 494 */     this.vertical.doLayout();
/*     */     
/* 496 */     this.ignoreScrollChange = false;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected Dimension updateScrollbarVisibility(int tx, int ty, int maxW, int maxH) {
/*     */     boolean bool2, bool1;
/* 508 */     Dimension vpSize = this.canvas.getSize();
/*     */ 
/*     */     
/* 511 */     int maxVPW = vpSize.width, minVPW = vpSize.width;
/* 512 */     int maxVPH = vpSize.height, minVPH = vpSize.height;
/*     */     
/* 514 */     if (this.vertical.isVisible()) {
/* 515 */       maxVPW += (this.vertical.getPreferredSize()).width;
/*     */     } else {
/* 517 */       minVPW -= (this.vertical.getPreferredSize()).width;
/*     */     } 
/* 519 */     if (this.horizontalPanel.isVisible()) {
/* 520 */       maxVPH += (this.horizontal.getPreferredSize()).height;
/*     */     } else {
/* 522 */       minVPH -= (this.horizontal.getPreferredSize()).height;
/*     */     } 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 531 */     Dimension ret = new Dimension();
/*     */     
/* 533 */     if (this.scrollbarsAlwaysVisible) {
/* 534 */       bool1 = (maxW > minVPW);
/* 535 */       bool2 = (maxH > minVPH);
/* 536 */       ret.width = minVPW;
/* 537 */       ret.height = minVPH;
/*     */     } else {
/* 539 */       bool1 = (maxW > maxVPW || tx != 0);
/* 540 */       bool2 = (maxH > maxVPH || ty != 0);
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */       
/* 548 */       if (bool2 && !bool1) { bool1 = (maxW > minVPW); }
/* 549 */       else if (bool1 && !bool2) { bool2 = (maxH > minVPH); }
/*     */       
/* 551 */       ret.width = bool1 ? minVPW : maxVPW;
/* 552 */       ret.height = bool2 ? minVPH : maxVPH;
/*     */     } 
/*     */     
/* 555 */     updateScrollbarState(bool1, bool2);
/*     */ 
/*     */     
/* 558 */     return ret;
/*     */   }
/*     */   
/*     */   protected void updateScrollbarState(boolean hNeeded, boolean vNeeded) {
/* 562 */     this.horizontal.setEnabled(hNeeded);
/* 563 */     this.vertical.setEnabled(vNeeded);
/*     */     
/* 565 */     if (this.scrollbarsAlwaysVisible) {
/* 566 */       this.horizontalPanel.setVisible(true);
/* 567 */       this.vertical.setVisible(true);
/* 568 */       this.cornerBox.setVisible(true);
/*     */     } else {
/* 570 */       this.horizontalPanel.setVisible(hNeeded);
/* 571 */       this.vertical.setVisible(vNeeded);
/* 572 */       this.cornerBox.setVisible((hNeeded && vNeeded));
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected void checkAndSetViewBoxRect() {
/* 582 */     if (this.viewBox != null)
/*     */       return; 
/* 584 */     this.viewBox = getViewBoxRect();
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected Rectangle2D getViewBoxRect() {
/* 592 */     SVGDocument doc = this.canvas.getSVGDocument();
/* 593 */     if (doc == null) return null; 
/* 594 */     SVGSVGElement el = doc.getRootElement();
/* 595 */     if (el == null) return null;
/*     */     
/* 597 */     String viewBoxStr = el.getAttributeNS(null, "viewBox");
/*     */     
/* 599 */     if (viewBoxStr.length() != 0) {
/* 600 */       float[] rect = ViewBox.parseViewBoxAttribute(el, viewBoxStr, null);
/* 601 */       return new Rectangle2D.Float(rect[0], rect[1], rect[2], rect[3]);
/*     */     } 
/*     */     
/* 604 */     GraphicsNode gn = this.canvas.getGraphicsNode();
/* 605 */     if (gn == null) return null;
/*     */     
/* 607 */     Rectangle2D bounds = gn.getBounds();
/* 608 */     if (bounds == null) return null;
/*     */     
/* 610 */     return (Rectangle2D)bounds.clone();
/*     */   }
/*     */   
/*     */   public void scaleChange(float scale) {}
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-swing.jar!\org\apache\batik\swing\JSVGScrollPane.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */