/*     */ package org.apache.batik.swing.gvt;
/*     */ 
/*     */ import java.awt.Cursor;
/*     */ import java.awt.event.MouseEvent;
/*     */ import java.awt.geom.AffineTransform;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class AbstractPanInteractor
/*     */   extends InteractorAdapter
/*     */ {
/*  39 */   public static final Cursor PAN_CURSOR = new Cursor(13);
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected boolean finished = true;
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected int xStart;
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected int yStart;
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected int xCurrent;
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected int yCurrent;
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected Cursor previousCursor;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  75 */   public boolean endInteraction() { return this.finished; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void mousePressed(MouseEvent e) {
/*  84 */     if (!this.finished) {
/*  85 */       mouseExited(e);
/*     */       
/*     */       return;
/*     */     } 
/*  89 */     this.finished = false;
/*     */     
/*  91 */     this.xStart = e.getX();
/*  92 */     this.yStart = e.getY();
/*     */     
/*  94 */     JGVTComponent c = (JGVTComponent)e.getSource();
/*     */     
/*  96 */     this.previousCursor = c.getCursor();
/*  97 */     c.setCursor(PAN_CURSOR);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void mouseReleased(MouseEvent e) {
/* 104 */     if (this.finished) {
/*     */       return;
/*     */     }
/* 107 */     this.finished = true;
/*     */     
/* 109 */     JGVTComponent c = (JGVTComponent)e.getSource();
/*     */     
/* 111 */     this.xCurrent = e.getX();
/* 112 */     this.yCurrent = e.getY();
/*     */     
/* 114 */     AffineTransform at = AffineTransform.getTranslateInstance((this.xCurrent - this.xStart), (this.yCurrent - this.yStart));
/*     */ 
/*     */     
/* 117 */     AffineTransform rt = (AffineTransform)c.getRenderingTransform().clone();
/*     */     
/* 119 */     rt.preConcatenate(at);
/* 120 */     c.setRenderingTransform(rt);
/*     */     
/* 122 */     if (c.getCursor() == PAN_CURSOR) {
/* 123 */       c.setCursor(this.previousCursor);
/*     */     }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void mouseExited(MouseEvent e) {
/* 131 */     this.finished = true;
/*     */     
/* 133 */     JGVTComponent c = (JGVTComponent)e.getSource();
/* 134 */     c.setPaintingTransform(null);
/* 135 */     if (c.getCursor() == PAN_CURSOR) {
/* 136 */       c.setCursor(this.previousCursor);
/*     */     }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void mouseDragged(MouseEvent e) {
/* 150 */     JGVTComponent c = (JGVTComponent)e.getSource();
/*     */     
/* 152 */     this.xCurrent = e.getX();
/* 153 */     this.yCurrent = e.getY();
/*     */     
/* 155 */     AffineTransform at = AffineTransform.getTranslateInstance((this.xCurrent - this.xStart), (this.yCurrent - this.yStart));
/*     */ 
/*     */     
/* 158 */     c.setPaintingTransform(at);
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-swing.jar!\org\apache\batik\swing\gvt\AbstractPanInteractor.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */