/*     */ package org.apache.batik.swing.gvt;
/*     */ 
/*     */ import java.awt.BasicStroke;
/*     */ import java.awt.Color;
/*     */ import java.awt.Dimension;
/*     */ import java.awt.Graphics;
/*     */ import java.awt.Graphics2D;
/*     */ import java.awt.event.MouseEvent;
/*     */ import java.awt.geom.AffineTransform;
/*     */ import java.awt.geom.Line2D;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class AbstractZoomInteractor
/*     */   extends InteractorAdapter
/*     */ {
/*     */   protected boolean finished = true;
/*     */   protected int xStart;
/*     */   protected int yStart;
/*     */   protected int xCurrent;
/*     */   protected int yCurrent;
/*     */   protected Line2D markerTop;
/*     */   protected Line2D markerLeft;
/*     */   protected Line2D markerBottom;
/*     */   protected Line2D markerRight;
/*  89 */   protected Overlay overlay = new ZoomOverlay(this);
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  94 */   protected BasicStroke markerStroke = new BasicStroke(1.0F, 2, 0, 10.0F, new float[] { 4.0F, 4.0F }, 0.0F);
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 104 */   public boolean endInteraction() { return this.finished; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void mousePressed(MouseEvent e) {
/* 113 */     if (!this.finished) {
/* 114 */       mouseExited(e);
/*     */       
/*     */       return;
/*     */     } 
/* 118 */     this.finished = false;
/* 119 */     this.markerTop = null;
/* 120 */     this.markerLeft = null;
/* 121 */     this.markerBottom = null;
/* 122 */     this.markerRight = null;
/*     */     
/* 124 */     this.xStart = e.getX();
/* 125 */     this.yStart = e.getY();
/* 126 */     JGVTComponent c = (JGVTComponent)e.getSource();
/* 127 */     c.getOverlays().add(this.overlay);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void mouseReleased(MouseEvent e) {
/* 134 */     this.finished = true;
/* 135 */     JGVTComponent c = (JGVTComponent)e.getSource();
/* 136 */     c.getOverlays().remove(this.overlay);
/* 137 */     this.overlay.paint(c.getGraphics());
/*     */     
/* 139 */     this.xCurrent = e.getX();
/* 140 */     this.yCurrent = e.getY();
/*     */     
/* 142 */     if (this.xCurrent - this.xStart != 0 && this.yCurrent - this.yStart != 0) {
/*     */ 
/*     */       
/* 145 */       int dx = this.xCurrent - this.xStart;
/* 146 */       int dy = this.yCurrent - this.yStart;
/*     */       
/* 148 */       if (dx < 0) {
/* 149 */         dx = -dx;
/* 150 */         this.xStart = this.xCurrent;
/*     */       } 
/* 152 */       if (dy < 0) {
/* 153 */         dy = -dy;
/* 154 */         this.yStart = this.yCurrent;
/*     */       } 
/*     */       
/* 157 */       Dimension size = c.getSize();
/*     */ 
/*     */       
/* 160 */       float scaleX = size.width / dx;
/* 161 */       float scaleY = size.height / dy;
/* 162 */       float scale = (scaleX < scaleY) ? scaleX : scaleY;
/*     */ 
/*     */       
/* 165 */       AffineTransform at = new AffineTransform();
/* 166 */       at.scale(scale, scale);
/* 167 */       at.translate(-this.xStart, -this.yStart);
/*     */       
/* 169 */       at.concatenate(c.getRenderingTransform());
/* 170 */       c.setRenderingTransform(at);
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void mouseExited(MouseEvent e) {
/* 178 */     this.finished = true;
/* 179 */     JGVTComponent c = (JGVTComponent)e.getSource();
/* 180 */     c.getOverlays().remove(this.overlay);
/* 181 */     this.overlay.paint(c.getGraphics());
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void mouseDragged(MouseEvent e) {
/*     */     float f4, f3, f2, f1;
/* 194 */     JGVTComponent c = (JGVTComponent)e.getSource();
/*     */     
/* 196 */     this.overlay.paint(c.getGraphics());
/*     */     
/* 198 */     this.xCurrent = e.getX();
/* 199 */     this.yCurrent = e.getY();
/*     */ 
/*     */ 
/*     */     
/* 203 */     if (this.xStart < this.xCurrent) {
/* 204 */       f1 = this.xStart;
/* 205 */       f3 = (this.xCurrent - this.xStart);
/*     */     } else {
/* 207 */       f1 = this.xCurrent;
/* 208 */       f3 = (this.xStart - this.xCurrent);
/*     */     } 
/* 210 */     if (this.yStart < this.yCurrent) {
/* 211 */       f2 = this.yStart;
/* 212 */       f4 = (this.yCurrent - this.yStart);
/*     */     } else {
/* 214 */       f2 = this.yCurrent;
/* 215 */       f4 = (this.yStart - this.yCurrent);
/*     */     } 
/* 217 */     Dimension d = c.getSize();
/* 218 */     float compAR = d.width / d.height;
/* 219 */     if (compAR > f3 / f4) {
/* 220 */       f3 = compAR * f4;
/*     */     } else {
/* 222 */       f4 = f3 / compAR;
/*     */     } 
/*     */     
/* 225 */     this.markerTop = new Line2D.Float(f1, f2, f1 + f3, f2);
/* 226 */     this.markerLeft = new Line2D.Float(f1, f2, f1, f2 + f4);
/* 227 */     this.markerBottom = new Line2D.Float(f1, f2 + f4, f1 + f3, f2 + f4);
/*     */     
/* 229 */     this.markerRight = new Line2D.Float(f1 + f3, f2, f1 + f3, f2 + f4);
/*     */ 
/*     */     
/* 232 */     this.overlay.paint(c.getGraphics());
/*     */   }
/*     */   
/*     */   protected class ZoomOverlay implements Overlay {
/*     */     private final AbstractZoomInteractor this$0;
/*     */     
/* 238 */     protected ZoomOverlay(AbstractZoomInteractor this$0) { this.this$0 = this$0; }
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*     */     public void paint(Graphics g) {
/* 244 */       if (this.this$0.markerTop != null) {
/* 245 */         Graphics2D g2d = (Graphics2D)g;
/*     */         
/* 247 */         g2d.setXORMode(Color.white);
/* 248 */         g2d.setColor(Color.black);
/* 249 */         g2d.setStroke(this.this$0.markerStroke);
/*     */         
/* 251 */         g2d.draw(this.this$0.markerTop);
/* 252 */         g2d.draw(this.this$0.markerLeft);
/* 253 */         g2d.draw(this.this$0.markerBottom);
/* 254 */         g2d.draw(this.this$0.markerRight);
/*     */       } 
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-swing.jar!\org\apache\batik\swing\gvt\AbstractZoomInteractor.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */