/*      */ package org.apache.batik.swing.svg;
/*      */ 
/*      */ import java.awt.Cursor;
/*      */ import java.awt.Dimension;
/*      */ import java.awt.EventQueue;
/*      */ import java.awt.Point;
/*      */ import java.awt.Rectangle;
/*      */ import java.awt.Shape;
/*      */ import java.awt.event.ComponentAdapter;
/*      */ import java.awt.event.ComponentEvent;
/*      */ import java.awt.event.KeyEvent;
/*      */ import java.awt.event.MouseEvent;
/*      */ import java.awt.geom.AffineTransform;
/*      */ import java.awt.geom.Dimension2D;
/*      */ import java.awt.geom.NoninvertibleTransformException;
/*      */ import java.awt.geom.Point2D;
/*      */ import java.awt.image.BufferedImage;
/*      */ import java.net.URL;
/*      */ import java.util.HashMap;
/*      */ import java.util.HashSet;
/*      */ import java.util.Iterator;
/*      */ import java.util.LinkedList;
/*      */ import java.util.List;
/*      */ import java.util.Map;
/*      */ import java.util.Set;
/*      */ import javax.swing.JOptionPane;
/*      */ import org.apache.batik.bridge.BridgeContext;
/*      */ import org.apache.batik.bridge.BridgeException;
/*      */ import org.apache.batik.bridge.BridgeExtension;
/*      */ import org.apache.batik.bridge.DefaultScriptSecurity;
/*      */ import org.apache.batik.bridge.DocumentLoader;
/*      */ import org.apache.batik.bridge.ExternalResourceSecurity;
/*      */ import org.apache.batik.bridge.RelaxedExternalResourceSecurity;
/*      */ import org.apache.batik.bridge.ScriptSecurity;
/*      */ import org.apache.batik.bridge.UpdateManager;
/*      */ import org.apache.batik.bridge.UpdateManagerEvent;
/*      */ import org.apache.batik.bridge.UpdateManagerListener;
/*      */ import org.apache.batik.bridge.UserAgent;
/*      */ import org.apache.batik.bridge.ViewBox;
/*      */ import org.apache.batik.bridge.svg12.SVG12BridgeContext;
/*      */ import org.apache.batik.dom.svg.SVGDOMImplementation;
/*      */ import org.apache.batik.dom.svg.SVGOMDocument;
/*      */ import org.apache.batik.dom.util.DOMUtilities;
/*      */ import org.apache.batik.dom.util.XLinkSupport;
/*      */ import org.apache.batik.ext.awt.image.spi.ImageTagRegistry;
/*      */ import org.apache.batik.gvt.CanvasGraphicsNode;
/*      */ import org.apache.batik.gvt.CompositeGraphicsNode;
/*      */ import org.apache.batik.gvt.GraphicsNode;
/*      */ import org.apache.batik.gvt.event.AWTEventDispatcher;
/*      */ import org.apache.batik.gvt.event.EventDispatcher;
/*      */ import org.apache.batik.gvt.renderer.ImageRenderer;
/*      */ import org.apache.batik.gvt.text.Mark;
/*      */ import org.apache.batik.swing.gvt.AbstractJGVTComponent;
/*      */ import org.apache.batik.swing.gvt.GVTTreeRendererEvent;
/*      */ import org.apache.batik.swing.gvt.JGVTComponent;
/*      */ import org.apache.batik.swing.gvt.JGVTComponentListener;
/*      */ import org.apache.batik.util.ParsedURL;
/*      */ import org.apache.batik.util.RunnableQueue;
/*      */ import org.apache.batik.util.SVGFeatureStrings;
/*      */ import org.apache.batik.util.XMLResourceDescriptor;
/*      */ import org.w3c.dom.DOMImplementation;
/*      */ import org.w3c.dom.Document;
/*      */ import org.w3c.dom.Element;
/*      */ import org.w3c.dom.svg.SVGAElement;
/*      */ import org.w3c.dom.svg.SVGDocument;
/*      */ import org.w3c.dom.svg.SVGSVGElement;
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ public class AbstractJSVGComponent
/*      */   extends JGVTComponent
/*      */ {
/*      */   public static final int AUTODETECT = 0;
/*      */   public static final int ALWAYS_DYNAMIC = 1;
/*      */   public static final int ALWAYS_STATIC = 2;
/*      */   public static final int ALWAYS_INTERACTIVE = 3;
/*      */   public static final String SCRIPT_ALERT = "script.alert";
/*      */   public static final String SCRIPT_PROMPT = "script.prompt";
/*      */   public static final String SCRIPT_CONFIRM = "script.confirm";
/*      */   public static final String BROKEN_LINK_TITLE = "broken.link.title";
/*      */   protected SVGDocumentLoader documentLoader;
/*      */   protected SVGDocumentLoader nextDocumentLoader;
/*      */   protected DocumentLoader loader;
/*      */   protected GVTTreeBuilder gvtTreeBuilder;
/*      */   protected GVTTreeBuilder nextGVTTreeBuilder;
/*      */   protected SVGLoadEventDispatcher svgLoadEventDispatcher;
/*      */   protected UpdateManager updateManager;
/*      */   protected UpdateManager nextUpdateManager;
/*      */   protected SVGDocument svgDocument;
/*  312 */   protected List svgDocumentLoaderListeners = new LinkedList();
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*  317 */   protected List gvtTreeBuilderListeners = new LinkedList();
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*  322 */   protected List svgLoadEventDispatcherListeners = new LinkedList();
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*  327 */   protected List linkActivationListeners = new LinkedList();
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*  332 */   protected List updateManagerListeners = new LinkedList();
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   protected UserAgent userAgent;
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   protected SVGUserAgent svgUserAgent;
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   protected BridgeContext bridgeContext;
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   protected String fragmentIdentifier;
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   protected boolean isDynamicDocument;
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   protected boolean isInteractiveDocument;
/*      */ 
/*      */ 
/*      */   
/*      */   protected boolean selfCallingDisableInteractions = false;
/*      */ 
/*      */ 
/*      */   
/*      */   protected boolean userSetDisableInteractions = false;
/*      */ 
/*      */ 
/*      */   
/*      */   protected int documentState;
/*      */ 
/*      */ 
/*      */   
/*      */   protected Dimension prevComponentSize;
/*      */ 
/*      */ 
/*      */   
/*  382 */   protected Runnable afterStopRunnable = null;
/*      */   
/*      */   protected SVGUpdateOverlay updateOverlay;
/*      */   
/*      */   protected boolean recenterOnResize = true;
/*      */   
/*  388 */   protected AffineTransform viewingTransform = null; protected int animationLimitingMode; protected float animationLimitingAmount; protected JSVGComponentListener jsvgComponentListener; public void dispose() { setSVGDocument(null); } public void setDisableInteractions(boolean b) { super.setDisableInteractions(b); if (!this.selfCallingDisableInteractions) this.userSetDisableInteractions = true;  } public void clearUserSetDisableInteractions() { this.userSetDisableInteractions = false; updateZoomAndPanEnable(this.svgDocument); } public void updateZoomAndPanEnable(Document doc) { if (this.userSetDisableInteractions) return;  if (doc == null) return;  try { Element root = doc.getDocumentElement(); String znp = root.getAttributeNS(null, "zoomAndPan"); boolean enable = "magnify".equals(znp); this.selfCallingDisableInteractions = true; setDisableInteractions(!enable); } finally { this.selfCallingDisableInteractions = false; }  } public boolean getRecenterOnResize() { return this.recenterOnResize; } public void setRecenterOnResize(boolean recenterOnResize) { this.recenterOnResize = recenterOnResize; } public boolean isDynamic() { return this.isDynamicDocument; } public boolean isInteractive() { return this.isInteractiveDocument; }
/*      */   public void setDocumentState(int state) { this.documentState = state; }
/*      */   public UpdateManager getUpdateManager() { if (this.svgLoadEventDispatcher != null) return this.svgLoadEventDispatcher.getUpdateManager();  if (this.nextUpdateManager != null) return this.nextUpdateManager;  return this.updateManager; }
/*      */   public void resumeProcessing() { if (this.updateManager != null) this.updateManager.resume();  }
/*      */   public void suspendProcessing() { if (this.updateManager != null) this.updateManager.suspend();  }
/*      */   public void stopProcessing() { this.nextDocumentLoader = null; this.nextGVTTreeBuilder = null; if (this.documentLoader != null)
/*      */       this.documentLoader.halt();  if (this.gvtTreeBuilder != null)
/*      */       this.gvtTreeBuilder.halt();  if (this.svgLoadEventDispatcher != null)
/*      */       this.svgLoadEventDispatcher.halt();  if (this.nextUpdateManager != null) { this.nextUpdateManager.interrupt(); this.nextUpdateManager = null; }  if (this.updateManager != null)
/*      */       this.updateManager.interrupt();  super.stopProcessing(); }
/*      */   public void loadSVGDocument(String url) { String oldURI = null; if (this.svgDocument != null)
/*      */       oldURI = this.svgDocument.getURL();  ParsedURL newURI = new ParsedURL(oldURI, url); stopThenRun(new Runnable(this, newURI) { private final ParsedURL val$newURI; private final AbstractJSVGComponent this$0;
/*      */           public void run() { String url = this.val$newURI.toString(); this.this$0.fragmentIdentifier = this.val$newURI.getRef(); this.this$0.loader = new DocumentLoader(this.this$0.userAgent); this.this$0.nextDocumentLoader = new SVGDocumentLoader(url, this.this$0.loader); this.this$0.nextDocumentLoader.setPriority(1); Iterator it = this.this$0.svgDocumentLoaderListeners.iterator(); while (it.hasNext())
/*      */               this.this$0.nextDocumentLoader.addSVGDocumentLoaderListener((SVGDocumentLoaderListener)it.next());  this.this$0.startDocumentLoader(); } }
/*      */       ); }
/*      */   private void startDocumentLoader() { this.documentLoader = this.nextDocumentLoader; this.nextDocumentLoader = null; this.documentLoader.start(); }
/*  404 */   public AbstractJSVGComponent() { this(null, false, false); } public void setDocument(Document doc) { if (doc != null && !(doc.getImplementation() instanceof SVGDOMImplementation)) { DOMImplementation impl = SVGDOMImplementation.getDOMImplementation(); Document d = DOMUtilities.deepCloneDocument(doc, impl); doc = d; }  setSVGDocument((SVGDocument)doc); } public void setSVGDocument(SVGDocument doc) { if (doc != null && !(doc.getImplementation() instanceof SVGDOMImplementation)) { DOMImplementation impl = SVGDOMImplementation.getDOMImplementation(); Document d = DOMUtilities.deepCloneDocument(doc, impl); doc = (SVGDocument)d; }  SVGDocument svgdoc = doc; stopThenRun(new Runnable(this, svgdoc) { private final SVGDocument val$svgdoc; private final AbstractJSVGComponent this$0; public void run() { this.this$0.installSVGDocument(this.val$svgdoc); } }
/*      */       ); } protected void stopThenRun(Runnable r) { if (this.afterStopRunnable != null) { this.afterStopRunnable = r; return; }  this.afterStopRunnable = r; stopProcessing(); if (this.documentLoader == null && this.gvtTreeBuilder == null && this.gvtTreeRenderer == null && this.svgLoadEventDispatcher == null && this.nextUpdateManager == null && this.updateManager == null) { Runnable asr = this.afterStopRunnable; this.afterStopRunnable = null; asr.run(); }  } protected void installSVGDocument(SVGDocument doc) { this.svgDocument = doc; if (this.bridgeContext != null) { this.bridgeContext.dispose(); this.bridgeContext = null; }  releaseRenderingReferences(); if (doc == null) { this.isDynamicDocument = false; this.isInteractiveDocument = false; this.disableInteractions = true; this.initialTransform = new AffineTransform(); setRenderingTransform(this.initialTransform, false); Rectangle vRect = getRenderRect(); repaint(vRect.x, vRect.y, vRect.width, vRect.height); return; }  this.bridgeContext = createBridgeContext((SVGOMDocument)doc); switch (this.documentState) { case 2: this.isDynamicDocument = false; this.isInteractiveDocument = false; break;case 3: this.isDynamicDocument = false; this.isInteractiveDocument = true; break;case 1: this.isDynamicDocument = true; this.isInteractiveDocument = true; break;case 0: this.isDynamicDocument = this.bridgeContext.isDynamicDocument(doc); this.isInteractiveDocument = (this.isDynamicDocument || this.bridgeContext.isInteractiveDocument(doc)); break; }  if (this.isInteractiveDocument) if (this.isDynamicDocument) { this.bridgeContext.setDynamicState(2); } else { this.bridgeContext.setDynamicState(1); }   setBridgeContextAnimationLimitingMode(); updateZoomAndPanEnable(doc); this.nextGVTTreeBuilder = new GVTTreeBuilder(doc, this.bridgeContext); this.nextGVTTreeBuilder.setPriority(1); Iterator it = this.gvtTreeBuilderListeners.iterator(); while (it.hasNext()) this.nextGVTTreeBuilder.addGVTTreeBuilderListener((GVTTreeBuilderListener)it.next());  initializeEventHandling(); if (this.gvtTreeBuilder == null && this.documentLoader == null && this.gvtTreeRenderer == null && this.svgLoadEventDispatcher == null && this.updateManager == null) startGVTTreeBuilder();  } protected void startGVTTreeBuilder() { this.gvtTreeBuilder = this.nextGVTTreeBuilder; this.nextGVTTreeBuilder = null; this.gvtTreeBuilder.start(); }
/*      */   public SVGDocument getSVGDocument() { return this.svgDocument; }
/*      */   public Dimension2D getSVGDocumentSize() { return this.bridgeContext.getDocumentSize(); }
/*      */   public String getFragmentIdentifier() { return this.fragmentIdentifier; }
/*      */   public void setFragmentIdentifier(String fi) { this.fragmentIdentifier = fi; if (computeRenderingTransform()) scheduleGVTRendering();  }
/*      */   public void flushImageCache() { ImageTagRegistry reg = ImageTagRegistry.getRegistry(); reg.flushCache(); }
/*      */   public void setGraphicsNode(GraphicsNode gn, boolean createDispatcher) { Dimension2D dim = this.bridgeContext.getDocumentSize(); Dimension mySz = new Dimension((int)dim.getWidth(), (int)dim.getHeight()); setMySize(mySz); SVGSVGElement elt = this.svgDocument.getRootElement(); this.prevComponentSize = getSize(); AffineTransform at = calculateViewingTransform(this.fragmentIdentifier, elt); CanvasGraphicsNode cgn = getCanvasGraphicsNode(gn); cgn.setViewingTransform(at); this.viewingTransform = null; this.initialTransform = new AffineTransform(); setRenderingTransform(this.initialTransform, false); this.jsvgComponentListener.updateMatrix(this.initialTransform); addJGVTComponentListener(this.jsvgComponentListener); addComponentListener(this.jsvgComponentListener); super.setGraphicsNode(gn, createDispatcher); }
/*      */   protected BridgeContext createBridgeContext(SVGOMDocument doc) { BridgeContext bridgeContext1; if (this.loader == null) this.loader = new DocumentLoader(this.userAgent);  if (doc.isSVG12()) { bridgeContext1 = new SVG12BridgeContext(this.userAgent, this.loader); } else { bridgeContext1 = new BridgeContext(this.userAgent, this.loader); }  return bridgeContext1; }
/*      */   protected void startSVGLoadEventDispatcher(GraphicsNode root) { UpdateManager um = new UpdateManager(this.bridgeContext, root, this.svgDocument); this.svgLoadEventDispatcher = new SVGLoadEventDispatcher(root, this.svgDocument, this.bridgeContext, um); Iterator it = this.svgLoadEventDispatcherListeners.iterator(); while (it.hasNext()) this.svgLoadEventDispatcher.addSVGLoadEventDispatcherListener((SVGLoadEventDispatcherListener)it.next());  this.svgLoadEventDispatcher.start(); }
/*      */   protected ImageRenderer createImageRenderer() { if (this.isDynamicDocument)
/*      */       return this.rendererFactory.createDynamicImageRenderer();  return this.rendererFactory.createStaticImageRenderer(); }
/*  416 */   public AbstractJSVGComponent(SVGUserAgent ua, boolean eventsEnabled, boolean selectableText) { super(eventsEnabled, selectableText);
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/* 1344 */     this.jsvgComponentListener = new JSVGComponentListener(this); this.svgUserAgent = ua; this.userAgent = new BridgeUserAgentWrapper(createUserAgent()); addSVGDocumentLoaderListener((SVGListener)this.listener); addGVTTreeBuilderListener((SVGListener)this.listener); addSVGLoadEventDispatcherListener((SVGListener)this.listener); if (this.updateOverlay != null) getOverlays().add(this.updateOverlay);  } public CanvasGraphicsNode getCanvasGraphicsNode() { return getCanvasGraphicsNode(this.gvtRoot); } protected CanvasGraphicsNode getCanvasGraphicsNode(GraphicsNode gn) { if (!(gn instanceof CompositeGraphicsNode)) return null;  CompositeGraphicsNode cgn = (CompositeGraphicsNode)gn; List children = cgn.getChildren(); if (children.size() == 0) return null;  gn = (GraphicsNode)children.get(0); if (!(gn instanceof CanvasGraphicsNode)) return null;  return (CanvasGraphicsNode)gn; } public AffineTransform getViewingTransform() { AffineTransform vt; synchronized (this) { vt = this.viewingTransform; if (vt == null) { CanvasGraphicsNode cgn = getCanvasGraphicsNode(); if (cgn != null) vt = cgn.getViewingTransform();  }  }  return vt; } public AffineTransform getViewBoxTransform() { AffineTransform at = getRenderingTransform(); if (at == null) { at = new AffineTransform(); } else { at = new AffineTransform(at); }  AffineTransform vt = getViewingTransform(); if (vt != null) at.concatenate(vt);  return at; } protected boolean computeRenderingTransform() { if (this.svgDocument == null || this.gvtRoot == null) return false;  boolean ret = updateRenderingTransform(); this.initialTransform = new AffineTransform(); if (!this.initialTransform.equals(getRenderingTransform())) { setRenderingTransform(this.initialTransform, false); ret = true; }  return ret; } protected AffineTransform calculateViewingTransform(String fragIdent, SVGSVGElement svgElt) { Dimension d = getSize(); if (d.width < 1) d.width = 1;  if (d.height < 1) d.height = 1;  return ViewBox.getViewTransform(fragIdent, svgElt, d.width, d.height, this.bridgeContext); } protected boolean updateRenderingTransform() { if (this.svgDocument == null || this.gvtRoot == null) return false;  try { SVGSVGElement elt = this.svgDocument.getRootElement(); Dimension d = getSize(); Dimension oldD = this.prevComponentSize; if (oldD == null) oldD = d;  this.prevComponentSize = d; if (d.width < 1) d.width = 1;  if (d.height < 1) d.height = 1;  AffineTransform at = calculateViewingTransform(this.fragmentIdentifier, elt); AffineTransform vt = getViewingTransform(); if (at.equals(vt)) return (oldD.width != d.width || oldD.height != d.height);  if (!this.recenterOnResize) return true;  Point2D pt = new Point2D.Float(oldD.width / 2.0F, oldD.height / 2.0F); AffineTransform rendAT = getRenderingTransform(); if (rendAT != null) try { AffineTransform invRendAT = rendAT.createInverse(); pt = invRendAT.transform(pt, null); } catch (NoninvertibleTransformException e) {}  if (vt != null) try { AffineTransform invVT = vt.createInverse(); pt = invVT.transform(pt, null); } catch (NoninvertibleTransformException e) {}  if (at != null) pt = at.transform(pt, null);  if (rendAT != null) pt = rendAT.transform(pt, null);  float dx = (float)((d.width / 2.0F) - pt.getX()); float dy = (float)((d.height / 2.0F) - pt.getY()); dx = ((dx < 0.0F) ? (int)(dx - 0.5D) : (int)(dx + 0.5D)); dy = ((dy < 0.0F) ? (int)(dy - 0.5D) : (int)(dy + 0.5D)); if (dx != 0.0F || dy != 0.0F) { rendAT.preConcatenate(AffineTransform.getTranslateInstance(dx, dy)); setRenderingTransform(rendAT, false); }  synchronized (this) { this.viewingTransform = at; }  Runnable r = new Runnable(this, at) {
/*      */           AffineTransform myAT; CanvasGraphicsNode myCGN; private final AffineTransform val$at; private final AbstractJSVGComponent this$0; public void run() { synchronized (this.this$0) { this.myCGN.setViewingTransform(this.myAT); if (this.this$0.viewingTransform == this.myAT) this.this$0.viewingTransform = null;  }  }
/*      */         }; UpdateManager um = getUpdateManager(); if (um != null) { um.getUpdateRunnableQueue().invokeLater(r); } else { r.run(); }  } catch (BridgeException e) { this.userAgent.displayError(e); }  return true; } protected void renderGVTTree() { Shape shape; if (!this.isInteractiveDocument || this.updateManager == null || !this.updateManager.isRunning()) { super.renderGVTTree(); return; }  Rectangle visRect = getRenderRect(); if (this.gvtRoot == null || visRect.width <= 0 || visRect.height <= 0) return;  AffineTransform inv = null; try { inv = this.renderingTransform.createInverse(); } catch (NoninvertibleTransformException e) {} if (inv == null) { shape = visRect; } else { shape = inv.createTransformedShape(visRect); }  RunnableQueue rq = this.updateManager.getUpdateRunnableQueue(); synchronized (rq.getIteratorLock()) { Iterator it = rq.iterator(); while (it.hasNext()) { Object next = it.next(); if (next instanceof AbstractJSVGComponent$1$UpdateRenderingRunnable) ((AbstractJSVGComponent$1$UpdateRenderingRunnable)next).deactivate();  }  }  rq.invokeLater(new AbstractJSVGComponent$1$UpdateRenderingRunnable(this, this.renderingTransform, this.doubleBufferedRendering, true, shape, visRect.width, visRect.height)); } protected void handleException(Exception e) { this.userAgent.displayError(e); } public void addSVGDocumentLoaderListener(SVGDocumentLoaderListener l) { this.svgDocumentLoaderListeners.add(l); } public void removeSVGDocumentLoaderListener(SVGDocumentLoaderListener l) { this.svgDocumentLoaderListeners.remove(l); } public void addGVTTreeBuilderListener(GVTTreeBuilderListener l) { this.gvtTreeBuilderListeners.add(l); } public void removeGVTTreeBuilderListener(GVTTreeBuilderListener l) { this.gvtTreeBuilderListeners.remove(l); } public void addSVGLoadEventDispatcherListener(SVGLoadEventDispatcherListener l) { this.svgLoadEventDispatcherListeners.add(l); } public void removeSVGLoadEventDispatcherListener(SVGLoadEventDispatcherListener l) { this.svgLoadEventDispatcherListeners.remove(l); } public void addLinkActivationListener(LinkActivationListener l) { this.linkActivationListeners.add(l); } public void removeLinkActivationListener(LinkActivationListener l) { this.linkActivationListeners.remove(l); } public void addUpdateManagerListener(UpdateManagerListener l) { this.updateManagerListeners.add(l); } public void removeUpdateManagerListener(UpdateManagerListener l) { this.updateManagerListeners.remove(l); } public void showAlert(String message) { JOptionPane.showMessageDialog(this, Messages.formatMessage("script.alert", new Object[] { message })); } public String showPrompt(String message) { return JOptionPane.showInputDialog(this, Messages.formatMessage("script.prompt", new Object[] { message })); } public String showPrompt(String message, String defaultValue) { return (String)JOptionPane.showInputDialog(this, Messages.formatMessage("script.prompt", new Object[] { message }), null, -1, null, null, defaultValue); } public boolean showConfirm(String message) { return (JOptionPane.showConfirmDialog(this, Messages.formatMessage("script.confirm", new Object[] { message }), "Confirm", 0) == 0); } public void setMySize(Dimension d) { setPreferredSize(d); invalidate(); } public void setAnimationLimitingNone() { this.animationLimitingMode = 0; if (this.bridgeContext != null) setBridgeContextAnimationLimitingMode();  } public void setAnimationLimitingCPU(float pc) { this.animationLimitingMode = 1; this.animationLimitingAmount = pc; if (this.bridgeContext != null) setBridgeContextAnimationLimitingMode();  } public void setAnimationLimitingFPS(float fps) { this.animationLimitingMode = 2; this.animationLimitingAmount = fps; if (this.bridgeContext != null) setBridgeContextAnimationLimitingMode();  } protected void setBridgeContextAnimationLimitingMode() { switch (this.animationLimitingMode) { case 0: this.bridgeContext.setAnimationLimitingNone(); break;case 1: this.bridgeContext.setAnimationLimitingCPU(this.animationLimitingAmount); break;case 2: this.bridgeContext.setAnimationLimitingFPS(this.animationLimitingAmount); break; }  } protected class JSVGComponentListener extends ComponentAdapter implements JGVTComponentListener {
/* 1347 */     float prevScale; float prevTransX; protected JSVGComponentListener(AbstractJSVGComponent this$0) { this.this$0 = this$0;
/*      */       
/* 1349 */       this.prevScale = 0.0F;
/* 1350 */       this.prevTransX = 0.0F;
/* 1351 */       this.prevTransY = 0.0F; }
/*      */      float prevTransY; private final AbstractJSVGComponent this$0;
/*      */     public void componentResized(ComponentEvent ce) {
/* 1354 */       if (this.this$0.isDynamicDocument && this.this$0.updateManager != null && this.this$0.updateManager.isRunning())
/*      */       {
/* 1356 */         this.this$0.updateManager.getUpdateRunnableQueue().invokeLater(new AbstractJSVGComponent$4(this));
/*      */       }
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public void componentTransformChanged(ComponentEvent event) {
/* 1368 */       AffineTransform at = this.this$0.getRenderingTransform();
/*      */       
/* 1370 */       float currScale = (float)Math.sqrt(at.getDeterminant());
/* 1371 */       float currTransX = (float)at.getTranslateX();
/* 1372 */       float currTransY = (float)at.getTranslateY();
/*      */       
/* 1374 */       boolean dispatchZoom = (currScale != this.prevScale);
/* 1375 */       boolean dispatchScroll = (currTransX != this.prevTransX || currTransY != this.prevTransY);
/*      */       
/* 1377 */       if (this.this$0.isDynamicDocument && this.this$0.updateManager != null && this.this$0.updateManager.isRunning())
/*      */       {
/* 1379 */         this.this$0.updateManager.getUpdateRunnableQueue().invokeLater(new AbstractJSVGComponent$5(this, dispatchZoom, dispatchScroll));
/*      */       }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */       
/* 1391 */       this.prevScale = currScale;
/* 1392 */       this.prevTransX = currTransX;
/* 1393 */       this.prevTransY = currTransY;
/*      */     }
/*      */     
/*      */     public void updateMatrix(AffineTransform at) {
/* 1397 */       this.prevScale = (float)Math.sqrt(at.getDeterminant());
/* 1398 */       this.prevTransX = (float)at.getTranslateX();
/* 1399 */       this.prevTransY = (float)at.getTranslateY();
/*      */     }
/*      */   }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/* 1408 */   protected AbstractJGVTComponent.Listener createListener() { return new SVGListener(this); }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   protected class SVGListener
/*      */     extends JGVTComponent.ExtendedListener
/*      */     implements SVGDocumentLoaderListener, GVTTreeBuilderListener, SVGLoadEventDispatcherListener, UpdateManagerListener
/*      */   {
/*      */     private final AbstractJSVGComponent this$0;
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/* 1424 */     protected SVGListener(AbstractJSVGComponent this$0) { super(this$0); this.this$0 = this$0; }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public void documentLoadingStarted(SVGDocumentLoaderEvent e) {}
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public void documentLoadingCompleted(SVGDocumentLoaderEvent e) {
/* 1439 */       if (this.this$0.nextDocumentLoader != null) {
/* 1440 */         this.this$0.startDocumentLoader();
/*      */         
/*      */         return;
/*      */       } 
/* 1444 */       this.this$0.documentLoader = null;
/* 1445 */       if (this.this$0.afterStopRunnable != null) {
/* 1446 */         EventQueue.invokeLater(this.this$0.afterStopRunnable);
/* 1447 */         this.this$0.afterStopRunnable = null;
/*      */         
/*      */         return;
/*      */       } 
/* 1451 */       this.this$0.setSVGDocument(e.getSVGDocument());
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public void documentLoadingCancelled(SVGDocumentLoaderEvent e) {
/* 1458 */       if (this.this$0.nextDocumentLoader != null) {
/* 1459 */         this.this$0.startDocumentLoader();
/*      */         
/*      */         return;
/*      */       } 
/* 1463 */       this.this$0.documentLoader = null;
/* 1464 */       if (this.this$0.afterStopRunnable != null) {
/* 1465 */         EventQueue.invokeLater(this.this$0.afterStopRunnable);
/* 1466 */         this.this$0.afterStopRunnable = null;
/*      */         
/*      */         return;
/*      */       } 
/* 1470 */       if (this.this$0.nextGVTTreeBuilder != null) {
/* 1471 */         this.this$0.startGVTTreeBuilder();
/*      */         return;
/*      */       } 
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public void documentLoadingFailed(SVGDocumentLoaderEvent e) {
/* 1480 */       if (this.this$0.nextDocumentLoader != null) {
/* 1481 */         this.this$0.startDocumentLoader();
/*      */         
/*      */         return;
/*      */       } 
/* 1485 */       this.this$0.documentLoader = null;
/* 1486 */       this.this$0.userAgent.displayError(((SVGDocumentLoader)e.getSource()).getException());
/*      */ 
/*      */       
/* 1489 */       if (this.this$0.afterStopRunnable != null) {
/* 1490 */         EventQueue.invokeLater(this.this$0.afterStopRunnable);
/* 1491 */         this.this$0.afterStopRunnable = null;
/*      */         return;
/*      */       } 
/* 1494 */       if (this.this$0.nextGVTTreeBuilder != null) {
/* 1495 */         this.this$0.startGVTTreeBuilder();
/*      */         return;
/*      */       } 
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public void gvtBuildStarted(GVTTreeBuilderEvent e) {
/* 1507 */       this.this$0.removeJGVTComponentListener(this.this$0.jsvgComponentListener);
/* 1508 */       this.this$0.removeComponentListener(this.this$0.jsvgComponentListener);
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public void gvtBuildCompleted(GVTTreeBuilderEvent e) {
/* 1515 */       if (this.this$0.nextGVTTreeBuilder != null) {
/* 1516 */         this.this$0.startGVTTreeBuilder();
/*      */         
/*      */         return;
/*      */       } 
/* 1520 */       this.this$0.loader = null;
/* 1521 */       this.this$0.gvtTreeBuilder = null;
/*      */       
/* 1523 */       if (this.this$0.afterStopRunnable != null) {
/* 1524 */         EventQueue.invokeLater(this.this$0.afterStopRunnable);
/* 1525 */         this.this$0.afterStopRunnable = null;
/*      */         
/*      */         return;
/*      */       } 
/* 1529 */       if (this.this$0.nextDocumentLoader != null) {
/* 1530 */         this.this$0.startDocumentLoader();
/*      */         
/*      */         return;
/*      */       } 
/* 1534 */       this.this$0.gvtRoot = null;
/*      */       
/* 1536 */       if (this.this$0.isDynamicDocument && this.this$0.eventsEnabled) {
/* 1537 */         this.this$0.startSVGLoadEventDispatcher(e.getGVTRoot());
/*      */       } else {
/* 1539 */         if (this.this$0.isInteractiveDocument) {
/* 1540 */           this.this$0.nextUpdateManager = new UpdateManager(this.this$0.bridgeContext, e.getGVTRoot(), this.this$0.svgDocument);
/*      */         }
/*      */ 
/*      */ 
/*      */         
/* 1545 */         this.this$0.setGraphicsNode(e.getGVTRoot(), false);
/*      */         
/* 1547 */         this.this$0.scheduleGVTRendering();
/*      */       } 
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public void gvtBuildCancelled(GVTTreeBuilderEvent e) {
/* 1555 */       if (this.this$0.nextGVTTreeBuilder != null) {
/* 1556 */         this.this$0.startGVTTreeBuilder();
/*      */         
/*      */         return;
/*      */       } 
/* 1560 */       this.this$0.loader = null;
/* 1561 */       this.this$0.gvtTreeBuilder = null;
/*      */       
/* 1563 */       if (this.this$0.afterStopRunnable != null) {
/* 1564 */         EventQueue.invokeLater(this.this$0.afterStopRunnable);
/* 1565 */         this.this$0.afterStopRunnable = null;
/*      */         
/*      */         return;
/*      */       } 
/* 1569 */       if (this.this$0.nextDocumentLoader != null) {
/* 1570 */         this.this$0.startDocumentLoader();
/*      */         return;
/*      */       } 
/* 1573 */       this.this$0.image = null;
/* 1574 */       this.this$0.repaint();
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public void gvtBuildFailed(GVTTreeBuilderEvent e) {
/* 1581 */       if (this.this$0.nextGVTTreeBuilder != null) {
/* 1582 */         this.this$0.startGVTTreeBuilder();
/*      */         
/*      */         return;
/*      */       } 
/* 1586 */       this.this$0.loader = null;
/* 1587 */       this.this$0.gvtTreeBuilder = null;
/*      */       
/* 1589 */       if (this.this$0.afterStopRunnable != null) {
/* 1590 */         EventQueue.invokeLater(this.this$0.afterStopRunnable);
/* 1591 */         this.this$0.afterStopRunnable = null;
/*      */         
/*      */         return;
/*      */       } 
/* 1595 */       if (this.this$0.nextDocumentLoader != null) {
/* 1596 */         this.this$0.startDocumentLoader();
/*      */         
/*      */         return;
/*      */       } 
/* 1600 */       GraphicsNode gn = e.getGVTRoot();
/* 1601 */       if (gn == null) {
/* 1602 */         this.this$0.image = null;
/* 1603 */         this.this$0.repaint();
/*      */       } else {
/* 1605 */         this.this$0.setGraphicsNode(gn, false);
/* 1606 */         this.this$0.computeRenderingTransform();
/*      */       } 
/* 1608 */       this.this$0.userAgent.displayError(((GVTTreeBuilder)e.getSource()).getException());
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public void svgLoadEventDispatchStarted(SVGLoadEventDispatcherEvent e) {}
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public void svgLoadEventDispatchCompleted(SVGLoadEventDispatcherEvent e) {
/* 1626 */       this.this$0.nextUpdateManager = this.this$0.svgLoadEventDispatcher.getUpdateManager();
/* 1627 */       this.this$0.svgLoadEventDispatcher = null;
/*      */       
/* 1629 */       if (this.this$0.afterStopRunnable != null) {
/* 1630 */         this.this$0.nextUpdateManager.interrupt();
/* 1631 */         this.this$0.nextUpdateManager = null;
/*      */         
/* 1633 */         EventQueue.invokeLater(this.this$0.afterStopRunnable);
/* 1634 */         this.this$0.afterStopRunnable = null;
/*      */         
/*      */         return;
/*      */       } 
/* 1638 */       if (this.this$0.nextGVTTreeBuilder != null) {
/* 1639 */         this.this$0.nextUpdateManager.interrupt();
/* 1640 */         this.this$0.nextUpdateManager = null;
/*      */         
/* 1642 */         this.this$0.startGVTTreeBuilder();
/*      */         return;
/*      */       } 
/* 1645 */       if (this.this$0.nextDocumentLoader != null) {
/* 1646 */         this.this$0.nextUpdateManager.interrupt();
/* 1647 */         this.this$0.nextUpdateManager = null;
/*      */         
/* 1649 */         this.this$0.startDocumentLoader();
/*      */         
/*      */         return;
/*      */       } 
/* 1653 */       this.this$0.setGraphicsNode(e.getGVTRoot(), false);
/*      */       
/* 1655 */       this.this$0.scheduleGVTRendering();
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public void svgLoadEventDispatchCancelled(SVGLoadEventDispatcherEvent e) {
/* 1663 */       this.this$0.nextUpdateManager = this.this$0.svgLoadEventDispatcher.getUpdateManager();
/* 1664 */       this.this$0.svgLoadEventDispatcher = null;
/*      */       
/* 1666 */       this.this$0.nextUpdateManager.interrupt();
/* 1667 */       this.this$0.nextUpdateManager = null;
/*      */       
/* 1669 */       if (this.this$0.afterStopRunnable != null) {
/* 1670 */         EventQueue.invokeLater(this.this$0.afterStopRunnable);
/* 1671 */         this.this$0.afterStopRunnable = null;
/*      */         
/*      */         return;
/*      */       } 
/* 1675 */       if (this.this$0.nextGVTTreeBuilder != null) {
/* 1676 */         this.this$0.startGVTTreeBuilder();
/*      */         return;
/*      */       } 
/* 1679 */       if (this.this$0.nextDocumentLoader != null) {
/* 1680 */         this.this$0.startDocumentLoader();
/*      */         return;
/*      */       } 
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public void svgLoadEventDispatchFailed(SVGLoadEventDispatcherEvent e) {
/* 1690 */       this.this$0.nextUpdateManager = this.this$0.svgLoadEventDispatcher.getUpdateManager();
/* 1691 */       this.this$0.svgLoadEventDispatcher = null;
/*      */       
/* 1693 */       this.this$0.nextUpdateManager.interrupt();
/* 1694 */       this.this$0.nextUpdateManager = null;
/*      */       
/* 1696 */       if (this.this$0.afterStopRunnable != null) {
/* 1697 */         EventQueue.invokeLater(this.this$0.afterStopRunnable);
/* 1698 */         this.this$0.afterStopRunnable = null;
/*      */         
/*      */         return;
/*      */       } 
/* 1702 */       if (this.this$0.nextGVTTreeBuilder != null) {
/* 1703 */         this.this$0.startGVTTreeBuilder();
/*      */         return;
/*      */       } 
/* 1706 */       if (this.this$0.nextDocumentLoader != null) {
/* 1707 */         this.this$0.startDocumentLoader();
/*      */         
/*      */         return;
/*      */       } 
/* 1711 */       GraphicsNode gn = e.getGVTRoot();
/* 1712 */       if (gn == null) {
/* 1713 */         this.this$0.image = null;
/* 1714 */         this.this$0.repaint();
/*      */       } else {
/* 1716 */         this.this$0.setGraphicsNode(gn, false);
/* 1717 */         this.this$0.computeRenderingTransform();
/*      */       } 
/* 1719 */       this.this$0.userAgent.displayError(((SVGLoadEventDispatcher)e.getSource()).getException());
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public void gvtRenderingCompleted(GVTTreeRendererEvent e) {
/* 1729 */       super.gvtRenderingCompleted(e);
/*      */       
/* 1731 */       if (this.this$0.afterStopRunnable != null) {
/* 1732 */         if (this.this$0.nextUpdateManager != null) {
/* 1733 */           this.this$0.nextUpdateManager.interrupt();
/* 1734 */           this.this$0.nextUpdateManager = null;
/*      */         } 
/* 1736 */         EventQueue.invokeLater(this.this$0.afterStopRunnable);
/* 1737 */         this.this$0.afterStopRunnable = null;
/*      */         
/*      */         return;
/*      */       } 
/* 1741 */       if (this.this$0.nextGVTTreeBuilder != null) {
/* 1742 */         if (this.this$0.nextUpdateManager != null) {
/* 1743 */           this.this$0.nextUpdateManager.interrupt();
/* 1744 */           this.this$0.nextUpdateManager = null;
/*      */         } 
/* 1746 */         this.this$0.startGVTTreeBuilder();
/*      */         return;
/*      */       } 
/* 1749 */       if (this.this$0.nextDocumentLoader != null) {
/* 1750 */         if (this.this$0.nextUpdateManager != null) {
/* 1751 */           this.this$0.nextUpdateManager.interrupt();
/* 1752 */           this.this$0.nextUpdateManager = null;
/*      */         } 
/* 1754 */         this.this$0.startDocumentLoader();
/*      */         
/*      */         return;
/*      */       } 
/* 1758 */       if (this.this$0.nextUpdateManager != null) {
/* 1759 */         this.this$0.updateManager = this.this$0.nextUpdateManager;
/* 1760 */         this.this$0.nextUpdateManager = null;
/* 1761 */         this.this$0.updateManager.addUpdateManagerListener(this);
/* 1762 */         this.this$0.updateManager.manageUpdates(this.this$0.renderer);
/*      */       } 
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public void gvtRenderingCancelled(GVTTreeRendererEvent e) {
/* 1770 */       super.gvtRenderingCancelled(e);
/*      */       
/* 1772 */       if (this.this$0.afterStopRunnable != null) {
/* 1773 */         if (this.this$0.nextUpdateManager != null) {
/* 1774 */           this.this$0.nextUpdateManager.interrupt();
/* 1775 */           this.this$0.nextUpdateManager = null;
/*      */         } 
/*      */         
/* 1778 */         EventQueue.invokeLater(this.this$0.afterStopRunnable);
/* 1779 */         this.this$0.afterStopRunnable = null;
/*      */         
/*      */         return;
/*      */       } 
/* 1783 */       if (this.this$0.nextGVTTreeBuilder != null) {
/* 1784 */         if (this.this$0.nextUpdateManager != null) {
/* 1785 */           this.this$0.nextUpdateManager.interrupt();
/* 1786 */           this.this$0.nextUpdateManager = null;
/*      */         } 
/*      */         
/* 1789 */         this.this$0.startGVTTreeBuilder();
/*      */         return;
/*      */       } 
/* 1792 */       if (this.this$0.nextDocumentLoader != null) {
/* 1793 */         if (this.this$0.nextUpdateManager != null) {
/* 1794 */           this.this$0.nextUpdateManager.interrupt();
/* 1795 */           this.this$0.nextUpdateManager = null;
/*      */         } 
/* 1797 */         this.this$0.startDocumentLoader();
/*      */         return;
/*      */       } 
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public void gvtRenderingFailed(GVTTreeRendererEvent e) {
/* 1806 */       super.gvtRenderingFailed(e);
/*      */       
/* 1808 */       if (this.this$0.afterStopRunnable != null) {
/* 1809 */         if (this.this$0.nextUpdateManager != null) {
/* 1810 */           this.this$0.nextUpdateManager.interrupt();
/* 1811 */           this.this$0.nextUpdateManager = null;
/*      */         } 
/*      */         
/* 1814 */         EventQueue.invokeLater(this.this$0.afterStopRunnable);
/* 1815 */         this.this$0.afterStopRunnable = null;
/*      */         
/*      */         return;
/*      */       } 
/* 1819 */       if (this.this$0.nextGVTTreeBuilder != null) {
/* 1820 */         if (this.this$0.nextUpdateManager != null) {
/* 1821 */           this.this$0.nextUpdateManager.interrupt();
/* 1822 */           this.this$0.nextUpdateManager = null;
/*      */         } 
/*      */         
/* 1825 */         this.this$0.startGVTTreeBuilder();
/*      */         return;
/*      */       } 
/* 1828 */       if (this.this$0.nextDocumentLoader != null) {
/* 1829 */         if (this.this$0.nextUpdateManager != null) {
/* 1830 */           this.this$0.nextUpdateManager.interrupt();
/* 1831 */           this.this$0.nextUpdateManager = null;
/*      */         } 
/*      */         
/* 1834 */         this.this$0.startDocumentLoader();
/*      */         return;
/*      */       } 
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/* 1845 */     public void managerStarted(UpdateManagerEvent e) { EventQueue.invokeLater(new AbstractJSVGComponent$6(this, e)); }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/* 1865 */     public void managerSuspended(UpdateManagerEvent e) { EventQueue.invokeLater(new AbstractJSVGComponent$7(this, e)); }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/* 1883 */     public void managerResumed(UpdateManagerEvent e) { EventQueue.invokeLater(new AbstractJSVGComponent$8(this, e)); }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/* 1901 */     public void managerStopped(UpdateManagerEvent e) { EventQueue.invokeLater(new AbstractJSVGComponent$9(this, e)); }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/* 1937 */     public void updateStarted(UpdateManagerEvent e) { EventQueue.invokeLater(new AbstractJSVGComponent$10(this, e)); }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public void updateCompleted(UpdateManagerEvent e) {
/*      */       try {
/* 1971 */         EventQueue.invokeAndWait(new AbstractJSVGComponent$11(this, e));
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */       
/*      */       }
/* 1998 */       catch (Exception ex) {}
/*      */ 
/*      */ 
/*      */       
/* 2002 */       EventQueue.invokeLater(new AbstractJSVGComponent$12(this, e));
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/* 2020 */     public void updateFailed(UpdateManagerEvent e) { EventQueue.invokeLater(new AbstractJSVGComponent$13(this, e)); }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     protected void dispatchKeyTyped(KeyEvent e) {
/* 2040 */       if (!this.this$0.isDynamicDocument) {
/* 2041 */         super.dispatchKeyTyped(e);
/*      */         
/*      */         return;
/*      */       } 
/* 2045 */       if (this.this$0.updateManager != null && this.this$0.updateManager.isRunning()) {
/* 2046 */         this.this$0.updateManager.getUpdateRunnableQueue().invokeLater(new AbstractJSVGComponent$14(this, e));
/*      */       }
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     protected void dispatchKeyPressed(KeyEvent e) {
/* 2060 */       if (!this.this$0.isDynamicDocument) {
/* 2061 */         super.dispatchKeyPressed(e);
/*      */         
/*      */         return;
/*      */       } 
/* 2065 */       if (this.this$0.updateManager != null && this.this$0.updateManager.isRunning()) {
/* 2066 */         this.this$0.updateManager.getUpdateRunnableQueue().invokeLater(new AbstractJSVGComponent$15(this, e));
/*      */       }
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     protected void dispatchKeyReleased(KeyEvent e) {
/* 2079 */       if (!this.this$0.isDynamicDocument) {
/* 2080 */         super.dispatchKeyReleased(e);
/*      */         
/*      */         return;
/*      */       } 
/* 2084 */       if (this.this$0.updateManager != null && this.this$0.updateManager.isRunning()) {
/* 2085 */         this.this$0.updateManager.getUpdateRunnableQueue().invokeLater(new AbstractJSVGComponent$16(this, e));
/*      */       }
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     protected void dispatchMouseClicked(MouseEvent e) {
/* 2098 */       if (!this.this$0.isInteractiveDocument) {
/* 2099 */         super.dispatchMouseClicked(e);
/*      */         
/*      */         return;
/*      */       } 
/* 2103 */       if (this.this$0.updateManager != null && this.this$0.updateManager.isRunning()) {
/* 2104 */         this.this$0.updateManager.getUpdateRunnableQueue().invokeLater(new AbstractJSVGComponent$17(this, e));
/*      */       }
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     protected void dispatchMousePressed(MouseEvent e) {
/* 2118 */       if (!this.this$0.isDynamicDocument) {
/* 2119 */         super.dispatchMousePressed(e);
/*      */         
/*      */         return;
/*      */       } 
/* 2123 */       if (this.this$0.updateManager != null && this.this$0.updateManager.isRunning()) {
/* 2124 */         this.this$0.updateManager.getUpdateRunnableQueue().invokeLater(new AbstractJSVGComponent$18(this, e));
/*      */       }
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     protected void dispatchMouseReleased(MouseEvent e) {
/* 2137 */       if (!this.this$0.isDynamicDocument) {
/* 2138 */         super.dispatchMouseReleased(e);
/*      */         
/*      */         return;
/*      */       } 
/* 2142 */       if (this.this$0.updateManager != null && this.this$0.updateManager.isRunning()) {
/* 2143 */         this.this$0.updateManager.getUpdateRunnableQueue().invokeLater(new AbstractJSVGComponent$19(this, e));
/*      */       }
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     protected void dispatchMouseEntered(MouseEvent e) {
/* 2156 */       if (!this.this$0.isInteractiveDocument) {
/* 2157 */         super.dispatchMouseEntered(e);
/*      */         
/*      */         return;
/*      */       } 
/* 2161 */       if (this.this$0.updateManager != null && this.this$0.updateManager.isRunning()) {
/* 2162 */         this.this$0.updateManager.getUpdateRunnableQueue().invokeLater(new AbstractJSVGComponent$20(this, e));
/*      */       }
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     protected void dispatchMouseExited(MouseEvent e) {
/* 2175 */       if (!this.this$0.isInteractiveDocument) {
/* 2176 */         super.dispatchMouseExited(e);
/*      */         
/*      */         return;
/*      */       } 
/* 2180 */       if (this.this$0.updateManager != null && this.this$0.updateManager.isRunning()) {
/* 2181 */         this.this$0.updateManager.getUpdateRunnableQueue().invokeLater(new AbstractJSVGComponent$21(this, e));
/*      */       }
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     protected void dispatchMouseDragged(MouseEvent e) {
/* 2194 */       if (!this.this$0.isDynamicDocument) {
/* 2195 */         super.dispatchMouseDragged(e);
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */         
/*      */         return;
/*      */       } 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */       
/* 2209 */       if (this.this$0.updateManager != null && this.this$0.updateManager.isRunning()) {
/* 2210 */         RunnableQueue rq = this.this$0.updateManager.getUpdateRunnableQueue();
/*      */ 
/*      */         
/* 2213 */         synchronized (rq.getIteratorLock()) {
/* 2214 */           Iterator it = rq.iterator();
/* 2215 */           while (it.hasNext()) {
/* 2216 */             Object next = it.next();
/* 2217 */             if (next instanceof AbstractJSVGComponent$1$MouseDraggedRunnable) {
/*      */               
/* 2219 */               AbstractJSVGComponent$1$MouseDraggedRunnable mdr = (AbstractJSVGComponent$1$MouseDraggedRunnable)next;
/* 2220 */               MouseEvent mev = mdr.event;
/* 2221 */               if (mev.getModifiers() == e.getModifiers()) {
/* 2222 */                 mdr.event = e;
/*      */               }
/*      */               
/*      */               return;
/*      */             } 
/*      */           } 
/*      */         } 
/* 2229 */         rq.invokeLater(new AbstractJSVGComponent$1$MouseDraggedRunnable(this, e));
/*      */       } 
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     protected void dispatchMouseMoved(MouseEvent e) {
/* 2237 */       if (!this.this$0.isInteractiveDocument) {
/* 2238 */         super.dispatchMouseMoved(e);
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */         
/*      */         return;
/*      */       } 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */       
/* 2252 */       if (this.this$0.updateManager != null && this.this$0.updateManager.isRunning()) {
/* 2253 */         RunnableQueue rq = this.this$0.updateManager.getUpdateRunnableQueue();
/*      */ 
/*      */         
/* 2256 */         int i = 0;
/* 2257 */         synchronized (rq.getIteratorLock()) {
/* 2258 */           Iterator it = rq.iterator();
/* 2259 */           while (it.hasNext()) {
/* 2260 */             Object next = it.next();
/* 2261 */             if (next instanceof AbstractJSVGComponent$1$MouseMovedRunnable) {
/*      */               
/* 2263 */               AbstractJSVGComponent$1$MouseMovedRunnable mmr = (AbstractJSVGComponent$1$MouseMovedRunnable)next;
/* 2264 */               MouseEvent mev = mmr.event;
/* 2265 */               if (mev.getModifiers() == e.getModifiers()) {
/* 2266 */                 mmr.event = e;
/*      */               }
/*      */               return;
/*      */             } 
/* 2270 */             i++;
/*      */           } 
/*      */         } 
/*      */ 
/*      */         
/* 2275 */         rq.invokeLater(new AbstractJSVGComponent$1$MouseMovedRunnable(this, e));
/*      */       } 
/*      */     }
/*      */   }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/* 2284 */   protected UserAgent createUserAgent() { return new BridgeUserAgent(this); }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   protected static class BridgeUserAgentWrapper
/*      */     implements UserAgent
/*      */   {
/*      */     protected UserAgent userAgent;
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/* 2301 */     public BridgeUserAgentWrapper(UserAgent ua) { this.userAgent = ua; }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public EventDispatcher getEventDispatcher() {
/* 2308 */       if (EventQueue.isDispatchThread()) {
/* 2309 */         return this.userAgent.getEventDispatcher();
/*      */       }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */       
/* 2317 */       AbstractJSVGComponent$1$Query q = new AbstractJSVGComponent$1$Query(this);
/* 2318 */       invokeAndWait(q);
/* 2319 */       return q.result;
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public Dimension2D getViewportSize() {
/* 2327 */       if (EventQueue.isDispatchThread()) {
/* 2328 */         return this.userAgent.getViewportSize();
/*      */       }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */       
/* 2336 */       AbstractJSVGComponent$2$Query q = new AbstractJSVGComponent$2$Query(this);
/* 2337 */       invokeAndWait(q);
/* 2338 */       return q.result;
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public void displayError(Exception ex) {
/* 2346 */       if (EventQueue.isDispatchThread()) {
/* 2347 */         this.userAgent.displayError(ex);
/*      */       } else {
/* 2349 */         EventQueue.invokeLater(new AbstractJSVGComponent$22(this, ex));
/*      */       } 
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public void displayMessage(String message) {
/* 2361 */       if (EventQueue.isDispatchThread()) {
/* 2362 */         this.userAgent.displayMessage(message);
/*      */       } else {
/* 2364 */         EventQueue.invokeLater(new AbstractJSVGComponent$23(this, message));
/*      */       } 
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public void showAlert(String message) {
/* 2376 */       if (EventQueue.isDispatchThread()) {
/* 2377 */         this.userAgent.showAlert(message);
/*      */       } else {
/* 2379 */         invokeAndWait(new AbstractJSVGComponent$24(this, message));
/*      */       } 
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public String showPrompt(String message) {
/* 2391 */       if (EventQueue.isDispatchThread()) {
/* 2392 */         return this.userAgent.showPrompt(message);
/*      */       }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */       
/* 2400 */       AbstractJSVGComponent$3$Query q = new AbstractJSVGComponent$3$Query(this, message);
/* 2401 */       invokeAndWait(q);
/* 2402 */       return q.result;
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public String showPrompt(String message, String defaultValue) {
/* 2411 */       if (EventQueue.isDispatchThread()) {
/* 2412 */         return this.userAgent.showPrompt(message, defaultValue);
/*      */       }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */       
/* 2420 */       AbstractJSVGComponent$4$Query q = new AbstractJSVGComponent$4$Query(this, message, defaultValue);
/* 2421 */       invokeAndWait(q);
/* 2422 */       return q.result;
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public boolean showConfirm(String message) {
/* 2430 */       if (EventQueue.isDispatchThread()) {
/* 2431 */         return this.userAgent.showConfirm(message);
/*      */       }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */       
/* 2439 */       AbstractJSVGComponent$5$Query q = new AbstractJSVGComponent$5$Query(this, message);
/* 2440 */       invokeAndWait(q);
/* 2441 */       return q.result;
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public float getPixelUnitToMillimeter() {
/* 2449 */       if (EventQueue.isDispatchThread()) {
/* 2450 */         return this.userAgent.getPixelUnitToMillimeter();
/*      */       }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */       
/* 2458 */       AbstractJSVGComponent$6$Query q = new AbstractJSVGComponent$6$Query(this);
/* 2459 */       invokeAndWait(q);
/* 2460 */       return q.result;
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/* 2469 */     public float getPixelToMM() { return getPixelUnitToMillimeter(); }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public String getDefaultFontFamily() {
/* 2476 */       if (EventQueue.isDispatchThread()) {
/* 2477 */         return this.userAgent.getDefaultFontFamily();
/*      */       }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */       
/* 2485 */       AbstractJSVGComponent$7$Query q = new AbstractJSVGComponent$7$Query(this);
/* 2486 */       invokeAndWait(q);
/* 2487 */       return q.result;
/*      */     }
/*      */ 
/*      */     
/*      */     public float getMediumFontSize() {
/* 2492 */       if (EventQueue.isDispatchThread()) {
/* 2493 */         return this.userAgent.getMediumFontSize();
/*      */       }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */       
/* 2501 */       AbstractJSVGComponent$8$Query q = new AbstractJSVGComponent$8$Query(this);
/* 2502 */       invokeAndWait(q);
/* 2503 */       return q.result;
/*      */     }
/*      */ 
/*      */     
/*      */     public float getLighterFontWeight(float f) {
/* 2508 */       if (EventQueue.isDispatchThread()) {
/* 2509 */         return this.userAgent.getLighterFontWeight(f);
/*      */       }
/* 2511 */       float ff = f;
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */       
/* 2518 */       AbstractJSVGComponent$9$Query q = new AbstractJSVGComponent$9$Query(this, ff);
/* 2519 */       invokeAndWait(q);
/* 2520 */       return q.result;
/*      */     }
/*      */ 
/*      */     
/*      */     public float getBolderFontWeight(float f) {
/* 2525 */       if (EventQueue.isDispatchThread()) {
/* 2526 */         return this.userAgent.getBolderFontWeight(f);
/*      */       }
/* 2528 */       float ff = f;
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */       
/* 2535 */       AbstractJSVGComponent$10$Query q = new AbstractJSVGComponent$10$Query(this, ff);
/* 2536 */       invokeAndWait(q);
/* 2537 */       return q.result;
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public String getLanguages() {
/* 2545 */       if (EventQueue.isDispatchThread()) {
/* 2546 */         return this.userAgent.getLanguages();
/*      */       }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */       
/* 2554 */       AbstractJSVGComponent$11$Query q = new AbstractJSVGComponent$11$Query(this);
/* 2555 */       invokeAndWait(q);
/* 2556 */       return q.result;
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public String getUserStyleSheetURI() {
/* 2565 */       if (EventQueue.isDispatchThread()) {
/* 2566 */         return this.userAgent.getUserStyleSheetURI();
/*      */       }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */       
/* 2574 */       AbstractJSVGComponent$12$Query q = new AbstractJSVGComponent$12$Query(this);
/* 2575 */       invokeAndWait(q);
/* 2576 */       return q.result;
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public void openLink(SVGAElement elt) {
/* 2585 */       if (EventQueue.isDispatchThread()) {
/* 2586 */         this.userAgent.openLink(elt);
/*      */       } else {
/* 2588 */         EventQueue.invokeLater(new AbstractJSVGComponent$25(this, elt));
/*      */       } 
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public void setSVGCursor(Cursor cursor) {
/* 2601 */       if (EventQueue.isDispatchThread()) {
/* 2602 */         this.userAgent.setSVGCursor(cursor);
/*      */       } else {
/* 2604 */         EventQueue.invokeLater(new AbstractJSVGComponent$26(this, cursor));
/*      */       } 
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public void setTextSelection(Mark start, Mark end) {
/* 2618 */       if (EventQueue.isDispatchThread()) {
/* 2619 */         this.userAgent.setTextSelection(start, end);
/*      */       } else {
/* 2621 */         EventQueue.invokeLater(new AbstractJSVGComponent$27(this, start, end));
/*      */       } 
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public void deselectAll() {
/* 2633 */       if (EventQueue.isDispatchThread()) {
/* 2634 */         this.userAgent.deselectAll();
/*      */       } else {
/* 2636 */         EventQueue.invokeLater(new AbstractJSVGComponent$28(this));
/*      */       } 
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public String getXMLParserClassName() {
/* 2648 */       if (EventQueue.isDispatchThread()) {
/* 2649 */         return this.userAgent.getXMLParserClassName();
/*      */       }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */       
/* 2657 */       AbstractJSVGComponent$13$Query q = new AbstractJSVGComponent$13$Query(this);
/* 2658 */       invokeAndWait(q);
/* 2659 */       return q.result;
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public boolean isXMLParserValidating() {
/* 2668 */       if (EventQueue.isDispatchThread()) {
/* 2669 */         return this.userAgent.isXMLParserValidating();
/*      */       }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */       
/* 2677 */       AbstractJSVGComponent$14$Query q = new AbstractJSVGComponent$14$Query(this);
/* 2678 */       invokeAndWait(q);
/* 2679 */       return q.result;
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public AffineTransform getTransform() {
/* 2688 */       if (EventQueue.isDispatchThread()) {
/* 2689 */         return this.userAgent.getTransform();
/*      */       }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */       
/* 2697 */       AbstractJSVGComponent$15$Query q = new AbstractJSVGComponent$15$Query(this);
/* 2698 */       invokeAndWait(q);
/* 2699 */       return q.result;
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public void setTransform(AffineTransform at) {
/* 2708 */       if (EventQueue.isDispatchThread()) {
/* 2709 */         this.userAgent.setTransform(at);
/*      */       } else {
/* 2711 */         AffineTransform affine = at;
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */         
/* 2717 */         AbstractJSVGComponent$16$Query q = new AbstractJSVGComponent$16$Query(this, affine);
/* 2718 */         invokeAndWait(q);
/*      */       } 
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public String getMedia() {
/* 2726 */       if (EventQueue.isDispatchThread()) {
/* 2727 */         return this.userAgent.getMedia();
/*      */       }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */       
/* 2735 */       AbstractJSVGComponent$17$Query q = new AbstractJSVGComponent$17$Query(this);
/* 2736 */       invokeAndWait(q);
/* 2737 */       return q.result;
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public String getAlternateStyleSheet() {
/* 2745 */       if (EventQueue.isDispatchThread()) {
/* 2746 */         return this.userAgent.getAlternateStyleSheet();
/*      */       }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */       
/* 2754 */       AbstractJSVGComponent$18$Query q = new AbstractJSVGComponent$18$Query(this);
/* 2755 */       invokeAndWait(q);
/* 2756 */       return q.result;
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public Point getClientAreaLocationOnScreen() {
/* 2765 */       if (EventQueue.isDispatchThread()) {
/* 2766 */         return this.userAgent.getClientAreaLocationOnScreen();
/*      */       }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */       
/* 2774 */       AbstractJSVGComponent$19$Query q = new AbstractJSVGComponent$19$Query(this);
/* 2775 */       invokeAndWait(q);
/* 2776 */       return q.result;
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public boolean hasFeature(String s) {
/* 2785 */       if (EventQueue.isDispatchThread()) {
/* 2786 */         return this.userAgent.hasFeature(s);
/*      */       }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */       
/* 2794 */       AbstractJSVGComponent$20$Query q = new AbstractJSVGComponent$20$Query(this, s);
/* 2795 */       invokeAndWait(q);
/* 2796 */       return q.result;
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public boolean supportExtension(String s) {
/* 2805 */       if (EventQueue.isDispatchThread()) {
/* 2806 */         return this.userAgent.supportExtension(s);
/*      */       }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */       
/* 2814 */       AbstractJSVGComponent$21$Query q = new AbstractJSVGComponent$21$Query(this, s);
/* 2815 */       invokeAndWait(q);
/* 2816 */       return q.result;
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public void registerExtension(BridgeExtension ext) {
/* 2825 */       if (EventQueue.isDispatchThread()) {
/* 2826 */         this.userAgent.registerExtension(ext);
/*      */       } else {
/* 2828 */         EventQueue.invokeLater(new AbstractJSVGComponent$29(this, ext));
/*      */       } 
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public void handleElement(Element elt, Object data) {
/* 2844 */       if (EventQueue.isDispatchThread()) {
/* 2845 */         this.userAgent.handleElement(elt, data);
/*      */       } else {
/* 2847 */         EventQueue.invokeLater(new AbstractJSVGComponent$30(this, elt, data));
/*      */       } 
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public ScriptSecurity getScriptSecurity(String scriptType, ParsedURL scriptPURL, ParsedURL docPURL) {
/* 2871 */       if (EventQueue.isDispatchThread()) {
/* 2872 */         return this.userAgent.getScriptSecurity(scriptType, scriptPURL, docPURL);
/*      */       }
/*      */ 
/*      */       
/* 2876 */       String st = scriptType;
/* 2877 */       ParsedURL sPURL = scriptPURL;
/* 2878 */       ParsedURL dPURL = docPURL;
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */       
/* 2885 */       AbstractJSVGComponent$22$Query q = new AbstractJSVGComponent$22$Query(this, st, sPURL, dPURL);
/* 2886 */       invokeAndWait(q);
/* 2887 */       return q.result;
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public void checkLoadScript(String scriptType, ParsedURL scriptPURL, ParsedURL docPURL) throws SecurityException {
/* 2912 */       if (EventQueue.isDispatchThread()) {
/* 2913 */         this.userAgent.checkLoadScript(scriptType, scriptPURL, docPURL);
/*      */       }
/*      */       else {
/*      */         
/* 2917 */         String st = scriptType;
/* 2918 */         ParsedURL sPURL = scriptPURL;
/* 2919 */         ParsedURL dPURL = docPURL;
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */         
/* 2930 */         AbstractJSVGComponent$23$Query q = new AbstractJSVGComponent$23$Query(this, st, sPURL, dPURL);
/* 2931 */         invokeAndWait(q);
/* 2932 */         if (q.se != null) {
/* 2933 */           q.se.fillInStackTrace();
/* 2934 */           throw q.se;
/*      */         } 
/*      */       } 
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public ExternalResourceSecurity getExternalResourceSecurity(ParsedURL resourcePURL, ParsedURL docPURL) {
/* 2954 */       if (EventQueue.isDispatchThread()) {
/* 2955 */         return this.userAgent.getExternalResourceSecurity(resourcePURL, docPURL);
/*      */       }
/*      */       
/* 2958 */       ParsedURL rPURL = resourcePURL;
/* 2959 */       ParsedURL dPURL = docPURL;
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */       
/* 2966 */       AbstractJSVGComponent$24$Query q = new AbstractJSVGComponent$24$Query(this, rPURL, dPURL);
/* 2967 */       invokeAndWait(q);
/* 2968 */       return q.result;
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public void checkLoadExternalResource(ParsedURL resourceURL, ParsedURL docURL) throws SecurityException {
/* 2991 */       if (EventQueue.isDispatchThread()) {
/* 2992 */         this.userAgent.checkLoadExternalResource(resourceURL, docURL);
/*      */       } else {
/*      */         
/* 2995 */         ParsedURL rPURL = resourceURL;
/* 2996 */         ParsedURL dPURL = docURL;
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */         
/* 3007 */         AbstractJSVGComponent$25$Query q = new AbstractJSVGComponent$25$Query(this, rPURL, dPURL);
/* 3008 */         invokeAndWait(q);
/* 3009 */         if (q.se != null) {
/* 3010 */           q.se.fillInStackTrace();
/* 3011 */           throw q.se;
/*      */         } 
/*      */       } 
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public SVGDocument getBrokenLinkDocument(Element e, String url, String msg) {
/* 3028 */       if (EventQueue.isDispatchThread()) {
/* 3029 */         return this.userAgent.getBrokenLinkDocument(e, url, msg);
/*      */       }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */       
/* 3040 */       AbstractJSVGComponent$26$Query q = new AbstractJSVGComponent$26$Query(this, e, url, msg);
/* 3041 */       invokeAndWait(q);
/* 3042 */       if (q.rex != null) throw q.rex; 
/* 3043 */       return q.doc;
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     protected void invokeAndWait(Runnable r) {
/*      */       try {
/* 3053 */         EventQueue.invokeAndWait(r);
/* 3054 */       } catch (Exception e) {}
/*      */     }
/*      */   }
/*      */ 
/*      */   
/*      */   protected class BridgeUserAgent
/*      */     implements UserAgent
/*      */   {
/*      */     protected Map extensions;
/*      */     
/*      */     private final AbstractJSVGComponent this$0;
/*      */     
/*      */     protected BridgeUserAgent(AbstractJSVGComponent this$0) {
/* 3067 */       this.this$0 = this$0;
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */       
/* 3442 */       this.extensions = new HashMap();
/*      */     } public Dimension2D getViewportSize() { return this.this$0.getSize(); } public EventDispatcher getEventDispatcher() { return this.this$0.eventDispatcher; } public void displayError(String message) { if (this.this$0.svgUserAgent != null) this.this$0.svgUserAgent.displayError(message);  } public void displayError(Exception ex) { if (this.this$0.svgUserAgent != null) this.this$0.svgUserAgent.displayError(ex);  } public void displayMessage(String message) { if (this.this$0.svgUserAgent != null) this.this$0.svgUserAgent.displayMessage(message);  } public void showAlert(String message) { if (this.this$0.svgUserAgent != null) { this.this$0.svgUserAgent.showAlert(message); return; }  this.this$0.showAlert(message); } public String showPrompt(String message) { if (this.this$0.svgUserAgent != null) return this.this$0.svgUserAgent.showPrompt(message);  return this.this$0.showPrompt(message); } public String showPrompt(String message, String defaultValue) { if (this.this$0.svgUserAgent != null) return this.this$0.svgUserAgent.showPrompt(message, defaultValue);  return this.this$0.showPrompt(message, defaultValue); } public boolean showConfirm(String message) { if (this.this$0.svgUserAgent != null) return this.this$0.svgUserAgent.showConfirm(message);  return this.this$0.showConfirm(message); } public float getPixelUnitToMillimeter() { if (this.this$0.svgUserAgent != null) return this.this$0.svgUserAgent.getPixelUnitToMillimeter();  return 0.26458332F; } public float getPixelToMM() { return getPixelUnitToMillimeter(); } public String getDefaultFontFamily() { if (this.this$0.svgUserAgent != null) return this.this$0.svgUserAgent.getDefaultFontFamily();  return "Arial, Helvetica, sans-serif"; } public float getMediumFontSize() { if (this.this$0.svgUserAgent != null) return this.this$0.svgUserAgent.getMediumFontSize();  return 228.59999F / 72.0F * getPixelUnitToMillimeter(); } public float getLighterFontWeight(float f) { if (this.this$0.svgUserAgent != null) return this.this$0.svgUserAgent.getLighterFontWeight(f);  int weight = (int)((f + 50.0F) / 100.0F) * 100; switch (weight) { case 100: return 100.0F;case 200: return 100.0F;case 300: return 200.0F;case 400: return 300.0F;case 500: return 400.0F;case 600: return 400.0F;case 700: return 400.0F;case 800: return 400.0F;case 900: return 400.0F; }  throw new IllegalArgumentException("Bad Font Weight: " + f); } public float getBolderFontWeight(float f) { if (this.this$0.svgUserAgent != null) return this.this$0.svgUserAgent.getBolderFontWeight(f);  int weight = (int)((f + 50.0F) / 100.0F) * 100; switch (weight) { case 100: return 600.0F;case 200: return 600.0F;case 300: return 600.0F;case 400: return 600.0F;case 500: return 600.0F;case 600: return 700.0F;case 700: return 800.0F;case 800: return 900.0F;case 900: return 900.0F; }  throw new IllegalArgumentException("Bad Font Weight: " + f); } public String getLanguages() { if (this.this$0.svgUserAgent != null) return this.this$0.svgUserAgent.getLanguages();  return "en"; } public String getUserStyleSheetURI() { if (this.this$0.svgUserAgent != null) return this.this$0.svgUserAgent.getUserStyleSheetURI();  return null; } public void openLink(SVGAElement elt) { String show = XLinkSupport.getXLinkShow(elt); String href = elt.getHref().getAnimVal(); if (show.equals("new")) { fireLinkActivatedEvent(elt, href); if (this.this$0.svgUserAgent != null) { String oldURI = this.this$0.svgDocument.getURL(); ParsedURL newURI = null; if (elt.getOwnerDocument() != this.this$0.svgDocument) { SVGDocument doc = (SVGDocument)elt.getOwnerDocument(); href = (new ParsedURL(doc.getURL(), href)).toString(); }  newURI = new ParsedURL(oldURI, href); href = newURI.toString(); this.this$0.svgUserAgent.openLink(href, true); } else { this.this$0.loadSVGDocument(href); }  return; }  ParsedURL newURI = new ParsedURL(((SVGDocument)elt.getOwnerDocument()).getURL(), href); href = newURI.toString(); if (this.this$0.svgDocument != null) { ParsedURL oldURI = new ParsedURL(this.this$0.svgDocument.getURL()); if (newURI.sameFile(oldURI)) { String s = newURI.getRef(); if (this.this$0.fragmentIdentifier != s && (s == null || !s.equals(this.this$0.fragmentIdentifier))) { this.this$0.fragmentIdentifier = s; if (this.this$0.computeRenderingTransform()) this.this$0.scheduleGVTRendering();  }  fireLinkActivatedEvent(elt, href); return; }  }  fireLinkActivatedEvent(elt, href); if (this.this$0.svgUserAgent != null) { this.this$0.svgUserAgent.openLink(href, false); } else { this.this$0.loadSVGDocument(href); }  } protected void fireLinkActivatedEvent(SVGAElement elt, String href) { Object[] ll = this.this$0.linkActivationListeners.toArray(); if (ll.length > 0) { LinkActivationEvent ev = new LinkActivationEvent(this.this$0, elt, href); for (int i = 0; i < ll.length; i++) { LinkActivationListener l = (LinkActivationListener)ll[i]; l.linkActivated(ev); }  }  } public void setSVGCursor(Cursor cursor) { if (cursor != this.this$0.getCursor()) this.this$0.setCursor(cursor);  } public void setTextSelection(Mark start, Mark end) { this.this$0.select(start, end); } public void deselectAll() { this.this$0.deselectAll(); } public String getXMLParserClassName() { if (this.this$0.svgUserAgent != null) return this.this$0.svgUserAgent.getXMLParserClassName();  return XMLResourceDescriptor.getXMLParserClassName(); } public boolean isXMLParserValidating() { if (this.this$0.svgUserAgent != null) return this.this$0.svgUserAgent.isXMLParserValidating();  return false; } public AffineTransform getTransform() { return this.this$0.renderingTransform; }
/*      */     public void setTransform(AffineTransform at) { this.this$0.setRenderingTransform(at); }
/*      */     public String getMedia() { if (this.this$0.svgUserAgent != null) return this.this$0.svgUserAgent.getMedia();  return "screen"; }
/*      */     public String getAlternateStyleSheet() { if (this.this$0.svgUserAgent != null) return this.this$0.svgUserAgent.getAlternateStyleSheet();  return null; }
/*      */     public Point getClientAreaLocationOnScreen() { return this.this$0.getLocationOnScreen(); }
/*      */     public boolean hasFeature(String s) { return AbstractJSVGComponent.FEATURES.contains(s); }
/* 3449 */     public boolean supportExtension(String s) { if (this.this$0.svgUserAgent != null && this.this$0.svgUserAgent.supportExtension(s))
/*      */       {
/* 3451 */         return true;
/*      */       }
/* 3453 */       return this.extensions.containsKey(s); }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public void registerExtension(BridgeExtension ext) {
/* 3461 */       Iterator i = ext.getImplementedExtensions();
/* 3462 */       while (i.hasNext()) {
/* 3463 */         this.extensions.put(i.next(), ext);
/*      */       }
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public void handleElement(Element elt, Object data) {
/* 3475 */       if (this.this$0.svgUserAgent != null) {
/* 3476 */         this.this$0.svgUserAgent.handleElement(elt, data);
/*      */       }
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public ScriptSecurity getScriptSecurity(String scriptType, ParsedURL scriptURL, ParsedURL docURL) {
/* 3496 */       if (this.this$0.svgUserAgent != null) {
/* 3497 */         return this.this$0.svgUserAgent.getScriptSecurity(scriptType, scriptURL, docURL);
/*      */       }
/*      */ 
/*      */       
/* 3501 */       return new DefaultScriptSecurity(scriptType, scriptURL, docURL);
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public void checkLoadScript(String scriptType, ParsedURL scriptURL, ParsedURL docURL) throws SecurityException {
/* 3528 */       if (this.this$0.svgUserAgent != null) {
/* 3529 */         this.this$0.svgUserAgent.checkLoadScript(scriptType, scriptURL, docURL);
/*      */       }
/*      */       else {
/*      */         
/* 3533 */         ScriptSecurity s = getScriptSecurity(scriptType, scriptURL, docURL);
/*      */ 
/*      */         
/* 3536 */         if (s != null) {
/* 3537 */           s.checkLoadScript();
/*      */         }
/*      */       } 
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public ExternalResourceSecurity getExternalResourceSecurity(ParsedURL resourceURL, ParsedURL docURL) {
/* 3556 */       if (this.this$0.svgUserAgent != null) {
/* 3557 */         return this.this$0.svgUserAgent.getExternalResourceSecurity(resourceURL, docURL);
/*      */       }
/*      */       
/* 3560 */       return new RelaxedExternalResourceSecurity(resourceURL, docURL);
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public void checkLoadExternalResource(ParsedURL resourceURL, ParsedURL docURL) throws SecurityException {
/* 3584 */       if (this.this$0.svgUserAgent != null) {
/* 3585 */         this.this$0.svgUserAgent.checkLoadExternalResource(resourceURL, docURL);
/*      */       } else {
/*      */         
/* 3588 */         ExternalResourceSecurity s = getExternalResourceSecurity(resourceURL, docURL);
/*      */ 
/*      */         
/* 3591 */         if (s != null) {
/* 3592 */           s.checkLoadExternalResource();
/*      */         }
/*      */       } 
/*      */     }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     
/*      */     public SVGDocument getBrokenLinkDocument(Element e, String url, String message) {
/* 3612 */       Class cls = AbstractJSVGComponent.class;
/* 3613 */       URL blURL = cls.getResource("resources/BrokenLink.svg");
/* 3614 */       if (blURL == null) {
/* 3615 */         throw new BridgeException(this.this$0.bridgeContext, e, "uri.image.broken", new Object[] { url, message });
/*      */       }
/*      */ 
/*      */       
/* 3619 */       DocumentLoader loader = this.this$0.bridgeContext.getDocumentLoader();
/* 3620 */       SVGDocument doc = null;
/*      */       
/*      */       try {
/* 3623 */         doc = (SVGDocument)loader.loadDocument(blURL.toString());
/* 3624 */         if (doc == null) return doc;
/*      */ 
/*      */         
/* 3627 */         DOMImplementation impl = SVGDOMImplementation.getDOMImplementation();
/* 3628 */         doc = (SVGDocument)DOMUtilities.deepCloneDocument(doc, impl);
/*      */ 
/*      */ 
/*      */         
/* 3632 */         Element infoE = doc.getElementById("__More_About");
/* 3633 */         if (infoE == null) return doc;
/*      */         
/* 3635 */         Element titleE = doc.createElementNS("http://www.w3.org/2000/svg", "title");
/*      */         
/* 3637 */         String title = Messages.formatMessage("broken.link.title", null);
/* 3638 */         titleE.appendChild(doc.createTextNode(title));
/*      */         
/* 3640 */         Element descE = doc.createElementNS("http://www.w3.org/2000/svg", "desc");
/*      */         
/* 3642 */         descE.appendChild(doc.createTextNode(message));
/*      */         
/* 3644 */         infoE.insertBefore(descE, infoE.getFirstChild());
/* 3645 */         infoE.insertBefore(titleE, descE);
/*      */       } catch (Exception ex) {
/* 3647 */         throw new BridgeException(this.this$0.bridgeContext, e, ex, "uri.image.broken", new Object[] { url, message });
/*      */       } 
/*      */ 
/*      */       
/* 3651 */       return doc;
/*      */     }
/*      */   }
/*      */   
/* 3655 */   protected static final Set FEATURES = new HashSet();
/*      */   static  {
/* 3657 */     SVGFeatureStrings.addSupportedFeatureStrings(FEATURES);
/*      */   }
/*      */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-swing.jar!\org\apache\batik\swing\svg\AbstractJSVGComponent.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */