/*     */ package org.apache.batik.swing.svg;
/*     */ 
/*     */ import org.apache.batik.bridge.ExternalResourceSecurity;
/*     */ import org.apache.batik.bridge.RelaxedExternalResourceSecurity;
/*     */ import org.apache.batik.bridge.RelaxedScriptSecurity;
/*     */ import org.apache.batik.bridge.ScriptSecurity;
/*     */ import org.apache.batik.util.ParsedURL;
/*     */ import org.apache.batik.util.XMLResourceDescriptor;
/*     */ import org.w3c.dom.Element;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class SVGUserAgentAdapter
/*     */   implements SVGUserAgent
/*     */ {
/*  59 */   public void displayError(String message) { System.err.println(message); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  66 */   public void displayError(Exception ex) { ex.printStackTrace(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  74 */   public void displayMessage(String message) { System.out.println(message); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  81 */   public void showAlert(String message) { System.err.println(message); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  88 */   public String showPrompt(String message) { return ""; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  95 */   public String showPrompt(String message, String defaultValue) { return defaultValue; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 102 */   public boolean showConfirm(String message) { return false; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 109 */   public float getPixelUnitToMillimeter() { return 0.26458332F; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 118 */   public float getPixelToMM() { return getPixelUnitToMillimeter(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 126 */   public String getDefaultFontFamily() { return "Serif"; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 134 */   public float getMediumFontSize() { return 228.59999F / 72.0F * getPixelUnitToMillimeter(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public float getLighterFontWeight(float f) {
/* 142 */     int weight = (int)((f + 50.0F) / 100.0F) * 100;
/* 143 */     switch (weight) { case 100:
/* 144 */         return 100.0F;
/* 145 */       case 200: return 100.0F;
/* 146 */       case 300: return 200.0F;
/* 147 */       case 400: return 300.0F;
/* 148 */       case 500: return 400.0F;
/* 149 */       case 600: return 400.0F;
/* 150 */       case 700: return 400.0F;
/* 151 */       case 800: return 400.0F;
/* 152 */       case 900: return 400.0F; }
/*     */     
/* 154 */     throw new IllegalArgumentException("Bad Font Weight: " + f);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public float getBolderFontWeight(float f) {
/* 163 */     int weight = (int)((f + 50.0F) / 100.0F) * 100;
/* 164 */     switch (weight) { case 100:
/* 165 */         return 600.0F;
/* 166 */       case 200: return 600.0F;
/* 167 */       case 300: return 600.0F;
/* 168 */       case 400: return 600.0F;
/* 169 */       case 500: return 600.0F;
/* 170 */       case 600: return 700.0F;
/* 171 */       case 700: return 800.0F;
/* 172 */       case 800: return 900.0F;
/* 173 */       case 900: return 900.0F; }
/*     */     
/* 175 */     throw new IllegalArgumentException("Bad Font Weight: " + f);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 184 */   public String getLanguages() { return "en"; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 192 */   public String getUserStyleSheetURI() { return null; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 199 */   public String getXMLParserClassName() { return XMLResourceDescriptor.getXMLParserClassName(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 207 */   public boolean isXMLParserValidating() { return false; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 214 */   public String getMedia() { return "screen"; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 221 */   public String getAlternateStyleSheet() { return null; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void openLink(String uri, boolean newc) {}
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 237 */   public boolean supportExtension(String s) { return false; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void handleElement(Element elt, Object data) {}
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 259 */   public ScriptSecurity getScriptSecurity(String scriptType, ParsedURL scriptURL, ParsedURL docURL) { return new RelaxedScriptSecurity(scriptType, scriptURL, docURL); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void checkLoadScript(String scriptType, ParsedURL scriptURL, ParsedURL docURL) throws SecurityException {
/* 294 */     ScriptSecurity s = getScriptSecurity(scriptType, scriptURL, docURL);
/*     */ 
/*     */ 
/*     */     
/* 298 */     if (s != null) {
/* 299 */       s.checkLoadScript();
/*     */     }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 317 */   public ExternalResourceSecurity getExternalResourceSecurity(ParsedURL resourceURL, ParsedURL docURL) { return new RelaxedExternalResourceSecurity(resourceURL, docURL); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void checkLoadExternalResource(ParsedURL resourceURL, ParsedURL docURL) throws SecurityException {
/* 346 */     ExternalResourceSecurity s = getExternalResourceSecurity(resourceURL, docURL);
/*     */ 
/*     */     
/* 349 */     if (s != null)
/* 350 */       s.checkLoadExternalResource(); 
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-swing.jar!\org\apache\batik\swing\svg\SVGUserAgentAdapter.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */