/*     */ package org.apache.batik.swing.gvt;
/*     */ 
/*     */ import java.awt.event.MouseEvent;
/*     */ import java.awt.geom.AffineTransform;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class AbstractImageZoomInteractor
/*     */   extends InteractorAdapter
/*     */ {
/*     */   protected boolean finished = true;
/*     */   protected int xStart;
/*     */   protected int yStart;
/*     */   protected int xCurrent;
/*     */   protected int yCurrent;
/*     */   
/*  64 */   public boolean endInteraction() { return this.finished; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void mousePressed(MouseEvent e) {
/*  73 */     if (!this.finished) {
/*  74 */       JGVTComponent c = (JGVTComponent)e.getSource();
/*  75 */       c.setPaintingTransform(null);
/*     */       
/*     */       return;
/*     */     } 
/*  79 */     this.finished = false;
/*     */     
/*  81 */     this.xStart = e.getX();
/*  82 */     this.yStart = e.getY();
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void mouseReleased(MouseEvent e) {
/*  89 */     this.finished = true;
/*     */     
/*  91 */     JGVTComponent c = (JGVTComponent)e.getSource();
/*     */     
/*  93 */     AffineTransform pt = c.getPaintingTransform();
/*  94 */     if (pt != null) {
/*  95 */       AffineTransform rt = (AffineTransform)c.getRenderingTransform().clone();
/*  96 */       rt.preConcatenate(pt);
/*  97 */       c.setRenderingTransform(rt);
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void mouseDragged(MouseEvent e) {
/*     */     double d;
/* 112 */     JGVTComponent c = (JGVTComponent)e.getSource();
/*     */     
/* 114 */     this.xCurrent = e.getX();
/* 115 */     this.yCurrent = e.getY();
/*     */     
/* 117 */     AffineTransform at = AffineTransform.getTranslateInstance(this.xStart, this.yStart);
/* 118 */     int dy = this.yCurrent - this.yStart;
/*     */     
/* 120 */     if (dy < 0) {
/* 121 */       dy -= 10;
/* 122 */       d = (dy > -15) ? 1.0D : (-15.0D / dy);
/*     */     } else {
/* 124 */       dy += 10;
/* 125 */       d = (dy < 15) ? 1.0D : (dy / 15.0D);
/*     */     } 
/*     */     
/* 128 */     at.scale(d, d);
/* 129 */     at.translate(-this.xStart, -this.yStart);
/* 130 */     c.setPaintingTransform(at);
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-swing.jar!\org\apache\batik\swing\gvt\AbstractImageZoomInteractor.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */