/*     */ package org.apache.batik.swing.gvt;
/*     */ 
/*     */ import java.awt.Dimension;
/*     */ import java.awt.event.MouseEvent;
/*     */ import java.awt.geom.AffineTransform;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class AbstractRotateInteractor
/*     */   extends InteractorAdapter
/*     */ {
/*     */   protected boolean finished;
/*     */   protected double initialRotation;
/*     */   
/*  50 */   public boolean endInteraction() { return this.finished; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void mousePressed(MouseEvent e) {
/*  59 */     this.finished = false;
/*  60 */     JGVTComponent c = (JGVTComponent)e.getSource();
/*     */     
/*  62 */     Dimension d = c.getSize();
/*  63 */     double dx = (e.getX() - d.width / 2);
/*  64 */     double dy = (e.getY() - d.height / 2);
/*  65 */     double cos = -dy / Math.sqrt(dx * dx + dy * dy);
/*  66 */     this.initialRotation = (dx > 0.0D) ? Math.acos(cos) : -Math.acos(cos);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void mouseReleased(MouseEvent e) {
/*  73 */     this.finished = true;
/*  74 */     JGVTComponent c = (JGVTComponent)e.getSource();
/*     */     
/*  76 */     AffineTransform at = rotateTransform(c.getSize(), e.getX(), e.getY());
/*  77 */     at.concatenate(c.getRenderingTransform());
/*  78 */     c.setRenderingTransform(at);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void mouseExited(MouseEvent e) {
/*  85 */     this.finished = true;
/*  86 */     JGVTComponent c = (JGVTComponent)e.getSource();
/*  87 */     c.setPaintingTransform(null);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void mouseDragged(MouseEvent e) {
/* 100 */     JGVTComponent c = (JGVTComponent)e.getSource();
/*     */     
/* 102 */     c.setPaintingTransform(rotateTransform(c.getSize(), e.getX(), e.getY()));
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected AffineTransform rotateTransform(Dimension d, int x, int y) {
/* 109 */     double dx = (x - d.width / 2);
/* 110 */     double dy = (y - d.height / 2);
/* 111 */     double cos = -dy / Math.sqrt(dx * dx + dy * dy);
/* 112 */     double angle = (dx > 0.0D) ? Math.acos(cos) : -Math.acos(cos);
/*     */     
/* 114 */     angle -= this.initialRotation;
/*     */     
/* 116 */     return AffineTransform.getRotateInstance(angle, (d.width / 2), (d.height / 2));
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-swing.jar!\org\apache\batik\swing\gvt\AbstractRotateInteractor.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */